From gcc-return-74461-obrien=freebsd.org@gcc.gnu.org  Fri May 16 14:51:46 2003
Delivered-To: obrien@freebsd.org
Return-Path: gcc-return-74461-obrien=freebsd.org@gcc.gnu.org
Received: from localhost
	by localhost with POP3 (fetchmail-6.2.0)
	for obrien@localhost (single-drop); Fri, 16 May 2003 14:51:46 -0700 (PDT)
Received: from mx1.FreeBSD.org (mx1.freebsd.org [216.136.204.125])
	by hub.freebsd.org (Postfix) with ESMTP id 519D037B401
	for <obrien@freebsd.org>; Fri, 16 May 2003 14:45:44 -0700 (PDT)
Received: from sources.redhat.com (sources.redhat.com [66.187.233.205])
	by mx1.FreeBSD.org (Postfix) with SMTP id 7A40A43F93
	for <obrien@freebsd.org>; Fri, 16 May 2003 14:45:43 -0700 (PDT)
	(envelope-from gcc-return-74461-obrien=freebsd.org@gcc.gnu.org)
Received: (qmail 26339 invoked by alias); 16 May 2003 21:44:02 -0000
Mailing-List: contact gcc-help@gcc.gnu.org; run by ezmlm
Precedence: bulk
List-Unsubscribe: <mailto:gcc-unsubscribe-obrien=freebsd.org@gcc.gnu.org>
List-Archive: <http://gcc.gnu.org/ml/gcc/>
List-Post: <mailto:gcc@gcc.gnu.org>
List-Help: <http://gcc.gnu.org/ml/>
Sender: gcc-owner@gcc.gnu.org
Delivered-To: mailing list gcc@gcc.gnu.org
Received: (qmail 26304 invoked from network); 16 May 2003 21:44:02 -0000
Received: from unknown (HELO rwcrmhc52.attbi.com) (216.148.227.88)
  by sources.redhat.com with SMTP; 16 May 2003 21:44:02 -0000
Received: from lucon.org (12-234-88-5.client.attbi.com[12.234.88.5])
          by attbi.com (rwcrmhc52) with ESMTP
          id <20030516214401052005pr01e>; Fri, 16 May 2003 21:44:01 +0000
Received: by lucon.org (Postfix, from userid 1000)
	id 755E12C681; Fri, 16 May 2003 14:44:01 -0700 (PDT)
Date: Fri, 16 May 2003 14:44:01 -0700
From: "H. J. Lu" <hjl@lucon.org>
To: gcc@gcc.gnu.org
Subject: Does gcc violate the ia64 ABI?
Message-ID: <20030516144401.A4222@lucon.org>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
User-Agent: Mutt/1.2.5.1i
X-UIDL: 0dd8c0996d101b255d5c4de2daf779fc
Status: RO
Content-Length: 860
Lines: 40

I will open a bug in gcc bugzilla when conversion is done. In the
meantime, I opened

https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=91056

The problem is gcc doesn't save/store gp across call. According to the
ia64 ABI, callee can change gp and gp must be saved/restore by caller
across calls. It is on page 5-2 in the Itanium Software Conventions
and Runtime Architecture Guide. Am I right?

# gcc -O2 -S x.c

H.J.
--x.c-
extern void foo ();
 
void
bar (void)
{
  foo ();
}
--x.s-
        .file   "x.c"
        .pred.safe_across_calls p1-p5,p16-p63
        .text
        .align 16
        .global bar#
        .proc bar#
bar:
        .prologue
        .body
        .bbb
        nop 0
        nop 0
        br.sptk.many foo#
        ;;
        break.f 0
        ;;
        .endp bar#
        .ident  "GCC: (GNU) 3.2.3 20030422 (Red Hat Linux 3.2.3-3)"

From gcc-return-74464-obrien=freebsd.org@gcc.gnu.org  Fri May 16 15:15:53 2003
Delivered-To: obrien@freebsd.org
Return-Path: gcc-return-74464-obrien=freebsd.org@gcc.gnu.org
Received: from localhost
	by localhost with POP3 (fetchmail-6.2.0)
	for obrien@localhost (single-drop); Fri, 16 May 2003 15:15:53 -0700 (PDT)
Received: from mx1.FreeBSD.org (mx1.freebsd.org [216.136.204.125])
	by hub.freebsd.org (Postfix) with ESMTP id 7E46137B404
	for <obrien@freebsd.org>; Fri, 16 May 2003 15:10:39 -0700 (PDT)
Received: from sources.redhat.com (sources.redhat.com [66.187.233.205])
	by mx1.FreeBSD.org (Postfix) with SMTP id E2F8F43FA3
	for <obrien@freebsd.org>; Fri, 16 May 2003 15:10:37 -0700 (PDT)
	(envelope-from gcc-return-74464-obrien=freebsd.org@gcc.gnu.org)
Received: (qmail 28899 invoked by alias); 16 May 2003 22:10:02 -0000
Mailing-List: contact gcc-help@gcc.gnu.org; run by ezmlm
Precedence: bulk
List-Unsubscribe: <mailto:gcc-unsubscribe-obrien=freebsd.org@gcc.gnu.org>
List-Archive: <http://gcc.gnu.org/ml/gcc/>
List-Post: <mailto:gcc@gcc.gnu.org>
List-Help: <http://gcc.gnu.org/ml/>
Sender: gcc-owner@gcc.gnu.org
Delivered-To: mailing list gcc@gcc.gnu.org
Received: (qmail 28832 invoked from network); 16 May 2003 22:10:00 -0000
Received: from unknown (HELO Cantor.suse.de) (213.95.15.193)
  by sources.redhat.com with SMTP; 16 May 2003 22:10:00 -0000
Received: from Hermes.suse.de (Hermes.suse.de [213.95.15.136])
	by Cantor.suse.de (Postfix) with ESMTP
	id 2FD6014A14; Sat, 17 May 2003 00:10:00 +0200 (MEST)
To: "H. J. Lu" <hjl@lucon.org>
Cc: gcc@gcc.gnu.org
Subject: Re: Does gcc violate the ia64 ABI?
References: <20030516144401.A4222@lucon.org>
From: Andreas Schwab <schwab@suse.de>
X-Yow: --Hello, POLICE?  I"ve got ABBOTT & COSTELLO here on suspicion of
 HIGHWAY ROBBERY!!
Date: Sat, 17 May 2003 00:09:58 +0200
In-Reply-To: <20030516144401.A4222@lucon.org> (H. J. Lu's message of "Fri,
 16 May 2003 14:44:01 -0700")
Message-ID: <je7k8q7dc9.fsf@sykes.suse.de>
User-Agent: Gnus/5.1001 (Gnus v5.10.1) Emacs/21.3.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: 8bit
X-UIDL: aedd677074fcaad46efec3f3beb750da
Status: RO
Content-Length: 859
Lines: 23

"H. J. Lu" <hjl@lucon.org> writes:

|> I will open a bug in gcc bugzilla when conversion is done. In the
|> meantime, I opened
|> 
|> https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=91056
|> 
|> The problem is gcc doesn't save/store gp across call. According to the
|> ia64 ABI, callee can change gp and gp must be saved/restore by caller
|> across calls. It is on page 5-2 in the Itanium Software Conventions
|> and Runtime Architecture Guide. Am I right?

I don't see where's the problem.  If a function does not use a
call-clobbered register there is no need for saving/restoring it.  It's
the duty of the caller to do it.

Andreas.

-- 
Andreas Schwab, SuSE Labs, schwab@suse.de
SuSE Linux AG, Deutschherrnstr. 15-19, D-90429 Nrnberg
Key fingerprint = 58CA 54C7 6D53 942B 1756  01D3 44D5 214B 8276 4ED5
"And now for something completely different."

From gcc-return-74466-obrien=freebsd.org@gcc.gnu.org  Fri May 16 15:32:01 2003
Delivered-To: obrien@freebsd.org
Return-Path: gcc-return-74466-obrien=freebsd.org@gcc.gnu.org
Received: from localhost
	by localhost with POP3 (fetchmail-6.2.0)
	for obrien@localhost (single-drop); Fri, 16 May 2003 15:32:01 -0700 (PDT)
Received: from mx1.FreeBSD.org (mx1.freebsd.org [216.136.204.125])
	by hub.freebsd.org (Postfix) with ESMTP id 9F85337B401
	for <obrien@freebsd.org>; Fri, 16 May 2003 15:25:14 -0700 (PDT)
Received: from sources.redhat.com (sources.redhat.com [66.187.233.205])
	by mx1.FreeBSD.org (Postfix) with SMTP id BA11343F75
	for <obrien@freebsd.org>; Fri, 16 May 2003 15:25:13 -0700 (PDT)
	(envelope-from gcc-return-74466-obrien=freebsd.org@gcc.gnu.org)
Received: (qmail 1199 invoked by alias); 16 May 2003 22:25:11 -0000
Mailing-List: contact gcc-help@gcc.gnu.org; run by ezmlm
Precedence: bulk
List-Unsubscribe: <mailto:gcc-unsubscribe-obrien=freebsd.org@gcc.gnu.org>
List-Archive: <http://gcc.gnu.org/ml/gcc/>
List-Post: <mailto:gcc@gcc.gnu.org>
List-Help: <http://gcc.gnu.org/ml/>
Sender: gcc-owner@gcc.gnu.org
Delivered-To: mailing list gcc@gcc.gnu.org
Received: (qmail 1166 invoked from network); 16 May 2003 22:25:09 -0000
Received: from unknown (HELO sccrmhc01.attbi.com) (204.127.202.61)
  by sources.redhat.com with SMTP; 16 May 2003 22:25:09 -0000
Received: from lucon.org (12-234-88-5.client.attbi.com[12.234.88.5])
          by attbi.com (sccrmhc01) with ESMTP
          id <20030516222508001001fma0e>; Fri, 16 May 2003 22:25:08 +0000
Received: by lucon.org (Postfix, from userid 1000)
	id 316402C681; Fri, 16 May 2003 15:25:08 -0700 (PDT)
Date: Fri, 16 May 2003 15:25:08 -0700
From: "H. J. Lu" <hjl@lucon.org>
To: Andreas Schwab <schwab@suse.de>
Cc: gcc@gcc.gnu.org
Subject: Re: Does gcc violate the ia64 ABI?
Message-ID: <20030516152508.A4885@lucon.org>
References: <20030516144401.A4222@lucon.org> <je7k8q7dc9.fsf@sykes.suse.de>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
User-Agent: Mutt/1.2.5.1i
In-Reply-To: <je7k8q7dc9.fsf@sykes.suse.de>; from schwab@suse.de on Sat, May 17, 2003 at 12:09:58AM +0200
X-UIDL: bacd4a93b80aa275a9a99ed087f68a9d
Status: RO
Content-Length: 1694
Lines: 42

On Sat, May 17, 2003 at 12:09:58AM +0200, Andreas Schwab wrote:
> "H. J. Lu" <hjl@lucon.org> writes:
> 
> |> I will open a bug in gcc bugzilla when conversion is done. In the
> |> meantime, I opened
> |> 
> |> https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=91056
> |> 
> |> The problem is gcc doesn't save/store gp across call. According to the
> |> ia64 ABI, callee can change gp and gp must be saved/restore by caller
> |> across calls. It is on page 5-2 in the Itanium Software Conventions
> |> and Runtime Architecture Guide. Am I right?
> 
> I don't see where's the problem.  If a function does not use a
> call-clobbered register there is no need for saving/restoring it.  It's
> the duty of the caller to do it.

gp is a special register in the ia64 ABI:

On page 5-2 in Itanium Software Conventions and Runtime Architecture
Guide, there are

...
a. On entry to a procedure, gp is guaranteed valide for that procedure.
b. At any direct procedure call, gp must be valid (for the caller). This
guarantees that an import stub (see Section 8.4.1) can access the linkage
table.
c. Any procedure call (indirect or direct) may modify gp - unless the call
is known to be local to the load module.
d. At procedure return, gp must be valid (for the returning prodecure).
This allows the compiler to optimize calls known to be local (i.e., the
exceptions to Rule 'c').

The effect of the rules is that gp must be treated as scratch register
at the point of call (i.e., it must be saved by the caller), and it must
be preserved from entry to exit.

Since bar () may modify gp, at the return of foo, gp must be valid for foo
even if foo doesn't use gp at all. Did I miss something here?


H.J.

From gcc-return-74479-obrien=freebsd.org@gcc.gnu.org  Fri May 16 17:49:46 2003
Delivered-To: obrien@freebsd.org
Return-Path: gcc-return-74479-obrien=freebsd.org@gcc.gnu.org
Received: from localhost
	by localhost with POP3 (fetchmail-6.2.0)
	for obrien@localhost (single-drop); Fri, 16 May 2003 17:49:46 -0700 (PDT)
Received: from mx1.FreeBSD.org (mx1.freebsd.org [216.136.204.125])
	by hub.freebsd.org (Postfix) with ESMTP id 44F7337B401
	for <obrien@freebsd.org>; Fri, 16 May 2003 17:45:53 -0700 (PDT)
Received: from sources.redhat.com (sources.redhat.com [66.187.233.205])
	by mx1.FreeBSD.org (Postfix) with SMTP id 01D8F43F93
	for <obrien@freebsd.org>; Fri, 16 May 2003 17:45:52 -0700 (PDT)
	(envelope-from gcc-return-74479-obrien=freebsd.org@gcc.gnu.org)
Received: (qmail 31899 invoked by alias); 17 May 2003 00:45:51 -0000
Mailing-List: contact gcc-help@gcc.gnu.org; run by ezmlm
Precedence: bulk
List-Unsubscribe: <mailto:gcc-unsubscribe-obrien=freebsd.org@gcc.gnu.org>
List-Archive: <http://gcc.gnu.org/ml/gcc/>
List-Post: <mailto:gcc@gcc.gnu.org>
List-Help: <http://gcc.gnu.org/ml/>
Sender: gcc-owner@gcc.gnu.org
Delivered-To: mailing list gcc@gcc.gnu.org
Received: (qmail 31883 invoked from network); 17 May 2003 00:45:50 -0000
Received: from unknown (HELO mx2.redhat.com) (66.187.237.31)
  by sources.redhat.com with SMTP; 17 May 2003 00:45:50 -0000
Received: from int-mx2.corp.redhat.com (int-mx2.corp.redhat.com [172.16.27.26])
	by mx2.redhat.com (8.11.6/8.11.6) with ESMTP id h4H0YtZ25042;
	Fri, 16 May 2003 20:34:55 -0400
Received: from potter.sfbay.redhat.com (potter.sfbay.redhat.com [172.16.27.15])
	by int-mx2.corp.redhat.com (8.11.6/8.11.6) with ESMTP id h4H0jmT29116;
	Fri, 16 May 2003 20:45:49 -0400
Received: from dot.sfbay.redhat.com (dot.sfbay.redhat.com [172.16.24.7])
	by potter.sfbay.redhat.com (8.11.6/8.11.6) with ESMTP id h4H0jmM31240;
	Fri, 16 May 2003 17:45:48 -0700
Received: (from rth@localhost)
	by dot.sfbay.redhat.com (8.11.6/8.11.6) id h4H0hI518269;
	Fri, 16 May 2003 17:43:18 -0700
X-Authentication-Warning: dot.sfbay.redhat.com: rth set sender to rth@redhat.com using -f
Date: Fri, 16 May 2003 17:43:18 -0700
From: Richard Henderson <rth@redhat.com>
To: "H. J. Lu" <hjl@lucon.org>
Cc: Andreas Schwab <schwab@suse.de>, gcc@gcc.gnu.org
Subject: Re: Does gcc violate the ia64 ABI?
Message-ID: <20030517004318.GA18262@redhat.com>
Mail-Followup-To: Richard Henderson <rth@redhat.com>,
	"H. J. Lu" <hjl@lucon.org>, Andreas Schwab <schwab@suse.de>,
	gcc@gcc.gnu.org
References: <20030516144401.A4222@lucon.org> <je7k8q7dc9.fsf@sykes.suse.de> <20030516152508.A4885@lucon.org>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <20030516152508.A4885@lucon.org>
User-Agent: Mutt/1.4i
X-UIDL: fada8323c17ead3d8e451d3a789bdee2
Status: RO
Content-Length: 562
Lines: 16

On Fri, May 16, 2003 at 03:25:08PM -0700, H. J. Lu wrote:
> d. At procedure return, gp must be valid (for the returning prodecure).
> This allows the compiler to optimize calls known to be local (i.e., the
> exceptions to Rule 'c').

I was not aware of this clause.  I'd have sworn it wasn't a part
of the ABI at one time...

Indeed, if this clause is truely correct, then virtually all of
the tail-call possibilities on ia64 are invalid.  Yes, statics
still can be done, but that's not nearly as frequent.

Can you find out when this got added to the ABI?


r~

From gcc-return-74482-obrien=freebsd.org@gcc.gnu.org  Fri May 16 18:46:23 2003
Delivered-To: obrien@freebsd.org
Return-Path: gcc-return-74482-obrien=freebsd.org@gcc.gnu.org
Received: from localhost
	by localhost with POP3 (fetchmail-6.2.0)
	for obrien@localhost (single-drop); Fri, 16 May 2003 18:46:23 -0700 (PDT)
Received: from mx1.FreeBSD.org (mx1.freebsd.org [216.136.204.125])
	by hub.freebsd.org (Postfix) with ESMTP id 6D9EA37B401
	for <obrien@freebsd.org>; Fri, 16 May 2003 18:45:26 -0700 (PDT)
Received: from sources.redhat.com (sources.redhat.com [66.187.233.205])
	by mx1.FreeBSD.org (Postfix) with SMTP id 8635A43F93
	for <obrien@freebsd.org>; Fri, 16 May 2003 18:45:25 -0700 (PDT)
	(envelope-from gcc-return-74482-obrien=freebsd.org@gcc.gnu.org)
Received: (qmail 24507 invoked by alias); 17 May 2003 01:45:23 -0000
Mailing-List: contact gcc-help@gcc.gnu.org; run by ezmlm
Precedence: bulk
List-Unsubscribe: <mailto:gcc-unsubscribe-obrien=freebsd.org@gcc.gnu.org>
List-Archive: <http://gcc.gnu.org/ml/gcc/>
List-Post: <mailto:gcc@gcc.gnu.org>
List-Help: <http://gcc.gnu.org/ml/>
Sender: gcc-owner@gcc.gnu.org
Delivered-To: mailing list gcc@gcc.gnu.org
Received: (qmail 24461 invoked from network); 17 May 2003 01:45:22 -0000
Received: from unknown (HELO rwcrmhc51.attbi.com) (204.127.198.38)
  by sources.redhat.com with SMTP; 17 May 2003 01:45:22 -0000
Received: from lucon.org (12-234-88-5.client.attbi.com[12.234.88.5])
          by attbi.com (rwcrmhc51) with ESMTP
          id <20030517014522051001v5ote>; Sat, 17 May 2003 01:45:22 +0000
Received: by lucon.org (Postfix, from userid 1000)
	id 0D9502C681; Fri, 16 May 2003 18:45:22 -0700 (PDT)
Date: Fri, 16 May 2003 18:45:22 -0700
From: "H. J. Lu" <hjl@lucon.org>
To: Richard Henderson <rth@redhat.com>,
	Andreas Schwab <schwab@suse.de>, gcc@gcc.gnu.org
Subject: Re: Does gcc violate the ia64 ABI?
Message-ID: <20030516184522.A7603@lucon.org>
References: <20030516144401.A4222@lucon.org> <je7k8q7dc9.fsf@sykes.suse.de> <20030516152508.A4885@lucon.org> <20030517004318.GA18262@redhat.com>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
User-Agent: Mutt/1.2.5.1i
In-Reply-To: <20030517004318.GA18262@redhat.com>; from rth@redhat.com on Fri, May 16, 2003 at 05:43:18PM -0700
X-UIDL: 52b36059f87d6819e96926748482aa4b
Status: RO
Content-Length: 818
Lines: 24

On Fri, May 16, 2003 at 05:43:18PM -0700, Richard Henderson wrote:
> On Fri, May 16, 2003 at 03:25:08PM -0700, H. J. Lu wrote:
> > d. At procedure return, gp must be valid (for the returning prodecure).
> > This allows the compiler to optimize calls known to be local (i.e., the
> > exceptions to Rule 'c').
> 
> I was not aware of this clause.  I'd have sworn it wasn't a part
> of the ABI at one time...
> 
> Indeed, if this clause is truely correct, then virtually all of
> the tail-call possibilities on ia64 are invalid.  Yes, statics
> still can be done, but that's not nearly as frequent.

Gcc can skip gp save/restore across a local call. Right now, gcc
saves and restores gp across a local call.

> 
> Can you find out when this got added to the ABI?
> 

Sure. BTW, the current one is dated May, 2001.


H.J.

From gcc-return-74493-obrien=freebsd.org@gcc.gnu.org  Sat May 17 11:26:34 2003
Delivered-To: obrien@freebsd.org
Return-Path: gcc-return-74493-obrien=freebsd.org@gcc.gnu.org
Received: from localhost
	by localhost with POP3 (fetchmail-6.2.0)
	for obrien@localhost (single-drop); Sat, 17 May 2003 11:26:34 -0700 (PDT)
Received: from mx1.FreeBSD.org (mx1.freebsd.org [216.136.204.125])
	by hub.freebsd.org (Postfix) with ESMTP id EA70137B401
	for <obrien@freebsd.org>; Sat, 17 May 2003 11:18:34 -0700 (PDT)
Received: from sources.redhat.com (sources.redhat.com [66.187.233.205])
	by mx1.FreeBSD.org (Postfix) with SMTP id D93C743FAF
	for <obrien@freebsd.org>; Sat, 17 May 2003 11:18:33 -0700 (PDT)
	(envelope-from gcc-return-74493-obrien=freebsd.org@gcc.gnu.org)
Received: (qmail 8069 invoked by alias); 17 May 2003 18:18:32 -0000
Mailing-List: contact gcc-help@gcc.gnu.org; run by ezmlm
Precedence: bulk
List-Unsubscribe: <mailto:gcc-unsubscribe-obrien=freebsd.org@gcc.gnu.org>
List-Archive: <http://gcc.gnu.org/ml/gcc/>
List-Post: <mailto:gcc@gcc.gnu.org>
List-Help: <http://gcc.gnu.org/ml/>
Sender: gcc-owner@gcc.gnu.org
Delivered-To: mailing list gcc@gcc.gnu.org
Received: (qmail 8031 invoked from network); 17 May 2003 18:18:32 -0000
Received: from unknown (HELO mx2.redhat.com) (66.187.237.31)
  by sources.redhat.com with SMTP; 17 May 2003 18:18:32 -0000
Received: from int-mx2.corp.redhat.com (int-mx2.corp.redhat.com [172.16.27.26])
	by mx2.redhat.com (8.11.6/8.11.6) with ESMTP id h4HI7ZZ17405;
	Sat, 17 May 2003 14:07:35 -0400
Received: from potter.sfbay.redhat.com (potter.sfbay.redhat.com [172.16.27.15])
	by int-mx2.corp.redhat.com (8.11.6/8.11.6) with ESMTP id h4HIIUT01887;
	Sat, 17 May 2003 14:18:30 -0400
Received: from dot.sfbay.redhat.com (dot.sfbay.redhat.com [172.16.24.7])
	by potter.sfbay.redhat.com (8.11.6/8.11.6) with ESMTP id h4HIITM09492;
	Sat, 17 May 2003 11:18:29 -0700
Received: (from rth@localhost)
	by dot.sfbay.redhat.com (8.11.6/8.11.6) id h4HIFxD18698;
	Sat, 17 May 2003 11:15:59 -0700
X-Authentication-Warning: dot.sfbay.redhat.com: rth set sender to rth@redhat.com using -f
Date: Sat, 17 May 2003 11:15:59 -0700
From: Richard Henderson <rth@redhat.com>
To: "H. J. Lu" <hjl@lucon.org>
Cc: Andreas Schwab <schwab@suse.de>, gcc@gcc.gnu.org
Subject: Re: Does gcc violate the ia64 ABI?
Message-ID: <20030517181559.GA18692@redhat.com>
Mail-Followup-To: Richard Henderson <rth@redhat.com>,
	"H. J. Lu" <hjl@lucon.org>, Andreas Schwab <schwab@suse.de>,
	gcc@gcc.gnu.org
References: <20030516144401.A4222@lucon.org> <je7k8q7dc9.fsf@sykes.suse.de> <20030516152508.A4885@lucon.org> <20030517004318.GA18262@redhat.com> <20030516184522.A7603@lucon.org>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <20030516184522.A7603@lucon.org>
User-Agent: Mutt/1.4i
X-UIDL: 965719029f05ca13f840bcc022107c66
Status: RO
Content-Length: 301
Lines: 10

On Fri, May 16, 2003 at 06:45:22PM -0700, H. J. Lu wrote:
> Gcc can skip gp save/restore across a local call. Right now, gcc
> saves and restores gp across a local call.

Indeed, but it also tail-calls to non-local functions, so
gcc is going to have a compatibility problem if we change
the ABI.


r~

From gcc-return-74498-obrien=freebsd.org@gcc.gnu.org  Sat May 17 13:51:23 2003
Delivered-To: obrien@freebsd.org
Return-Path: gcc-return-74498-obrien=freebsd.org@gcc.gnu.org
Received: from localhost
	by localhost with POP3 (fetchmail-6.2.0)
	for obrien@localhost (single-drop); Sat, 17 May 2003 13:51:23 -0700 (PDT)
Received: from mx1.FreeBSD.org (mx1.freebsd.org [216.136.204.125])
	by hub.freebsd.org (Postfix) with ESMTP id BCC6537B401
	for <obrien@freebsd.org>; Sat, 17 May 2003 13:43:21 -0700 (PDT)
Received: from sources.redhat.com (sources.redhat.com [66.187.233.205])
	by mx1.FreeBSD.org (Postfix) with SMTP id CEDDD43FBD
	for <obrien@freebsd.org>; Sat, 17 May 2003 13:43:20 -0700 (PDT)
	(envelope-from gcc-return-74498-obrien=freebsd.org@gcc.gnu.org)
Received: (qmail 4053 invoked by alias); 17 May 2003 20:43:19 -0000
Mailing-List: contact gcc-help@gcc.gnu.org; run by ezmlm
Precedence: bulk
List-Unsubscribe: <mailto:gcc-unsubscribe-obrien=freebsd.org@gcc.gnu.org>
List-Archive: <http://gcc.gnu.org/ml/gcc/>
List-Post: <mailto:gcc@gcc.gnu.org>
List-Help: <http://gcc.gnu.org/ml/>
Sender: gcc-owner@gcc.gnu.org
Delivered-To: mailing list gcc@gcc.gnu.org
Received: (qmail 4046 invoked from network); 17 May 2003 20:43:18 -0000
Received: from unknown (HELO sccrmhc03.attbi.com) (204.127.202.63)
  by sources.redhat.com with SMTP; 17 May 2003 20:43:18 -0000
Received: from lucon.org (12-234-88-5.client.attbi.com[12.234.88.5])
          by attbi.com (sccrmhc03) with ESMTP
          id <2003051720431800300efac9e>; Sat, 17 May 2003 20:43:18 +0000
Received: by lucon.org (Postfix, from userid 1000)
	id F0A7D2C683; Sat, 17 May 2003 13:43:17 -0700 (PDT)
Date: Sat, 17 May 2003 13:43:17 -0700
From: "H. J. Lu" <hjl@lucon.org>
To: Richard Henderson <rth@redhat.com>,
	Andreas Schwab <schwab@suse.de>, gcc@gcc.gnu.org
Subject: Re: Does gcc violate the ia64 ABI?
Message-ID: <20030517134317.B22720@lucon.org>
References: <20030516144401.A4222@lucon.org> <je7k8q7dc9.fsf@sykes.suse.de> <20030516152508.A4885@lucon.org> <20030517004318.GA18262@redhat.com> <20030516184522.A7603@lucon.org> <20030517181559.GA18692@redhat.com>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
User-Agent: Mutt/1.2.5.1i
In-Reply-To: <20030517181559.GA18692@redhat.com>; from rth@redhat.com on Sat, May 17, 2003 at 11:15:59AM -0700
X-UIDL: 42217f413c0e29d6738f4f596692d746
Status: RO
Content-Length: 874
Lines: 25

On Sat, May 17, 2003 at 11:15:59AM -0700, Richard Henderson wrote:
> On Fri, May 16, 2003 at 06:45:22PM -0700, H. J. Lu wrote:
> > Gcc can skip gp save/restore across a local call. Right now, gcc
> > saves and restores gp across a local call.
> 
> Indeed, but it also tail-calls to non-local functions, so
> gcc is going to have a compatibility problem if we change
> the ABI.
> 

That is very unfortunate. We have several choices:

1. Do nothing. It is very bad.
2. Fix gcc and use a bit in ELF header to indicate the ABI change.
Linker will make sure no mixed .o/.so files.
3. Fix gcc and use a special empty note section to indicate the ABI
change. Linker will make sure no mixed .o/.so files.

I prefer 3, 2, 1, in that order.

BTW, Clause 'd' is in my Sept. 2000 copy of the runtime guide. It may
have been there for a long time. We must have missed it somehow.


H.J.

From gcc-return-74505-obrien=freebsd.org@gcc.gnu.org  Sat May 17 17:04:55 2003
Delivered-To: obrien@freebsd.org
Return-Path: gcc-return-74505-obrien=freebsd.org@gcc.gnu.org
Received: from localhost
	by localhost with POP3 (fetchmail-6.2.0)
	for obrien@localhost (single-drop); Sat, 17 May 2003 17:04:55 -0700 (PDT)
Received: from mx1.FreeBSD.org (mx1.freebsd.org [216.136.204.125])
	by hub.freebsd.org (Postfix) with ESMTP id 94C9F37B401
	for <obrien@freebsd.org>; Sat, 17 May 2003 17:02:03 -0700 (PDT)
Received: from sources.redhat.com (sources.redhat.com [66.187.233.205])
	by mx1.FreeBSD.org (Postfix) with SMTP id 7C96043FB1
	for <obrien@freebsd.org>; Sat, 17 May 2003 17:02:02 -0700 (PDT)
	(envelope-from gcc-return-74505-obrien=freebsd.org@gcc.gnu.org)
Received: (qmail 20481 invoked by alias); 18 May 2003 00:02:01 -0000
Mailing-List: contact gcc-help@gcc.gnu.org; run by ezmlm
Precedence: bulk
List-Unsubscribe: <mailto:gcc-unsubscribe-obrien=freebsd.org@gcc.gnu.org>
List-Archive: <http://gcc.gnu.org/ml/gcc/>
List-Post: <mailto:gcc@gcc.gnu.org>
List-Help: <http://gcc.gnu.org/ml/>
Sender: gcc-owner@gcc.gnu.org
Delivered-To: mailing list gcc@gcc.gnu.org
Received: (qmail 20472 invoked from network); 18 May 2003 00:02:01 -0000
Received: from unknown (HELO mx2.redhat.com) (66.187.237.31)
  by sources.redhat.com with SMTP; 18 May 2003 00:02:01 -0000
Received: from int-mx2.corp.redhat.com (int-mx2.corp.redhat.com [172.16.27.26])
	by mx2.redhat.com (8.11.6/8.11.6) with ESMTP id h4HNp4Z25436;
	Sat, 17 May 2003 19:51:04 -0400
Received: from potter.sfbay.redhat.com (potter.sfbay.redhat.com [172.16.27.15])
	by int-mx2.corp.redhat.com (8.11.6/8.11.6) with ESMTP id h4I01xT14295;
	Sat, 17 May 2003 20:01:59 -0400
Received: from dot.sfbay.redhat.com (dot.sfbay.redhat.com [172.16.24.7])
	by potter.sfbay.redhat.com (8.11.6/8.11.6) with ESMTP id h4I01wM22891;
	Sat, 17 May 2003 17:01:58 -0700
Received: (from rth@localhost)
	by dot.sfbay.redhat.com (8.11.6/8.11.6) id h4HNxTP18784;
	Sat, 17 May 2003 16:59:29 -0700
X-Authentication-Warning: dot.sfbay.redhat.com: rth set sender to rth@redhat.com using -f
Date: Sat, 17 May 2003 16:59:28 -0700
From: Richard Henderson <rth@redhat.com>
To: "H. J. Lu" <hjl@lucon.org>
Cc: Andreas Schwab <schwab@suse.de>, gcc@gcc.gnu.org
Subject: Re: Does gcc violate the ia64 ABI?
Message-ID: <20030517235928.GA18777@redhat.com>
Mail-Followup-To: Richard Henderson <rth@redhat.com>,
	"H. J. Lu" <hjl@lucon.org>, Andreas Schwab <schwab@suse.de>,
	gcc@gcc.gnu.org
References: <20030516144401.A4222@lucon.org> <je7k8q7dc9.fsf@sykes.suse.de> <20030516152508.A4885@lucon.org> <20030517004318.GA18262@redhat.com> <20030516184522.A7603@lucon.org> <20030517181559.GA18692@redhat.com> <20030517134317.B22720@lucon.org>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <20030517134317.B22720@lucon.org>
User-Agent: Mutt/1.4i
X-UIDL: 0cc6c0aafe99693ad6ed81b3075a1ca7
Status: RO
Content-Length: 667
Lines: 17

On Sat, May 17, 2003 at 01:43:17PM -0700, H. J. Lu wrote:
> 2. Fix gcc and use a bit in ELF header to indicate the ABI change.
> Linker will make sure no mixed .o/.so files.
> 3. Fix gcc and use a special empty note section to indicate the ABI
> change. Linker will make sure no mixed .o/.so files.

Neither of these are viable.  Some other, presumably conforming
psABI compiler will not emit either of these.

> BTW, Clause 'd' is in my Sept. 2000 copy of the runtime guide. It may
> have been there for a long time. We must have missed it somehow.

Hardly conclusive.  We need to go back to at least 1998 
to know if someone changed the ABI out from under us.


r~

From gcc-return-74507-obrien=freebsd.org@gcc.gnu.org  Sat May 17 18:57:31 2003
Delivered-To: obrien@freebsd.org
Return-Path: gcc-return-74507-obrien=freebsd.org@gcc.gnu.org
Received: from localhost
	by localhost with POP3 (fetchmail-6.2.0)
	for obrien@localhost (single-drop); Sat, 17 May 2003 18:57:31 -0700 (PDT)
Received: from mx1.FreeBSD.org (mx1.freebsd.org [216.136.204.125])
	by hub.freebsd.org (Postfix) with ESMTP id D562A37B401
	for <obrien@freebsd.org>; Sat, 17 May 2003 18:56:03 -0700 (PDT)
Received: from sources.redhat.com (sources.redhat.com [66.187.233.205])
	by mx1.FreeBSD.org (Postfix) with SMTP id DEA5443FAF
	for <obrien@freebsd.org>; Sat, 17 May 2003 18:56:02 -0700 (PDT)
	(envelope-from gcc-return-74507-obrien=freebsd.org@gcc.gnu.org)
Received: (qmail 19791 invoked by alias); 18 May 2003 01:55:59 -0000
Mailing-List: contact gcc-help@gcc.gnu.org; run by ezmlm
Precedence: bulk
List-Unsubscribe: <mailto:gcc-unsubscribe-obrien=freebsd.org@gcc.gnu.org>
List-Archive: <http://gcc.gnu.org/ml/gcc/>
List-Post: <mailto:gcc@gcc.gnu.org>
List-Help: <http://gcc.gnu.org/ml/>
Sender: gcc-owner@gcc.gnu.org
Delivered-To: mailing list gcc@gcc.gnu.org
Received: (qmail 19466 invoked from network); 18 May 2003 01:55:58 -0000
Received: from unknown (HELO rwcrmhc52.attbi.com) (216.148.227.88)
  by sources.redhat.com with SMTP; 18 May 2003 01:55:58 -0000
Received: from lucon.org (12-234-88-5.client.attbi.com[12.234.88.5])
          by attbi.com (rwcrmhc52) with ESMTP
          id <2003051801555705200g4anre>; Sun, 18 May 2003 01:55:57 +0000
Received: by lucon.org (Postfix, from userid 1000)
	id BF26D2C683; Sat, 17 May 2003 18:55:57 -0700 (PDT)
Date: Sat, 17 May 2003 18:55:57 -0700
From: "H. J. Lu" <hjl@lucon.org>
To: Richard Henderson <rth@redhat.com>,
	Andreas Schwab <schwab@suse.de>, gcc@gcc.gnu.org
Subject: Re: Does gcc violate the ia64 ABI?
Message-ID: <20030517185557.A27138@lucon.org>
References: <20030516144401.A4222@lucon.org> <je7k8q7dc9.fsf@sykes.suse.de> <20030516152508.A4885@lucon.org> <20030517004318.GA18262@redhat.com> <20030516184522.A7603@lucon.org> <20030517181559.GA18692@redhat.com> <20030517134317.B22720@lucon.org> <20030517235928.GA18777@redhat.com>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
User-Agent: Mutt/1.2.5.1i
In-Reply-To: <20030517235928.GA18777@redhat.com>; from rth@redhat.com on Sat, May 17, 2003 at 04:59:28PM -0700
X-UIDL: 2aaa3c0bfd3cd749e4915b926459c92d
Status: RO
Content-Length: 1221
Lines: 30

On Sat, May 17, 2003 at 04:59:28PM -0700, Richard Henderson wrote:
> On Sat, May 17, 2003 at 01:43:17PM -0700, H. J. Lu wrote:
> > 2. Fix gcc and use a bit in ELF header to indicate the ABI change.
> > Linker will make sure no mixed .o/.so files.
> > 3. Fix gcc and use a special empty note section to indicate the ABI
> > change. Linker will make sure no mixed .o/.so files.
> 
> Neither of these are viable.  Some other, presumably conforming
> psABI compiler will not emit either of these.

It is a problem for those conforming compilers who have to use
libraries compiled with gcc. We can talk to them and ask them what
they think. If they want to safely optimize the code, they may come
up with something everyone can live with.

> 
> > BTW, Clause 'd' is in my Sept. 2000 copy of the runtime guide. It may
> > have been there for a long time. We must have missed it somehow.
> 
> Hardly conclusive.  We need to go back to at least 1998 
> to know if someone changed the ABI out from under us.
> 

I have asked. I will let you know what I find out. But it won't
change the unfortunate fact that gcc doesn't conform to the ia64
psABI, which everyone has to live with. I hope we can find some
kind of solution.


H.J.

From gcc-return-74741-obrien=freebsd.org@gcc.gnu.org  Tue May 20 15:59:18 2003
Delivered-To: obrien@freebsd.org
Return-Path: gcc-return-74741-obrien=freebsd.org@gcc.gnu.org
Received: from localhost
	by localhost with POP3 (fetchmail-6.2.0)
	for obrien@localhost (single-drop); Tue, 20 May 2003 15:59:18 -0700 (PDT)
Received: from mx1.FreeBSD.org (mx1.freebsd.org [216.136.204.125])
	by hub.freebsd.org (Postfix) with ESMTP id 0822C37B401
	for <obrien@freebsd.org>; Tue, 20 May 2003 15:58:59 -0700 (PDT)
Received: from sources.redhat.com (sources.redhat.com [66.187.233.205])
	by mx1.FreeBSD.org (Postfix) with SMTP id 15F3643F93
	for <obrien@freebsd.org>; Tue, 20 May 2003 15:58:58 -0700 (PDT)
	(envelope-from gcc-return-74741-obrien=freebsd.org@gcc.gnu.org)
Received: (qmail 25625 invoked by alias); 20 May 2003 22:58:56 -0000
Mailing-List: contact gcc-help@gcc.gnu.org; run by ezmlm
Precedence: bulk
List-Unsubscribe: <mailto:gcc-unsubscribe-obrien=freebsd.org@gcc.gnu.org>
List-Archive: <http://gcc.gnu.org/ml/gcc/>
List-Post: <mailto:gcc@gcc.gnu.org>
List-Help: <http://gcc.gnu.org/ml/>
Sender: gcc-owner@gcc.gnu.org
Delivered-To: mailing list gcc@gcc.gnu.org
Received: (qmail 25593 invoked from network); 20 May 2003 22:58:56 -0000
Received: from unknown (HELO sccrmhc02.attbi.com) (204.127.202.62)
  by sources.redhat.com with SMTP; 20 May 2003 22:58:56 -0000
Received: from lucon.org (12-234-88-5.client.attbi.com[12.234.88.5])
          by attbi.com (sccrmhc02) with ESMTP
          id <2003052022585500200ck8gqe>; Tue, 20 May 2003 22:58:55 +0000
Received: by lucon.org (Postfix, from userid 1000)
	id EC1232C683; Tue, 20 May 2003 15:58:54 -0700 (PDT)
Date: Tue, 20 May 2003 15:58:54 -0700
From: "H. J. Lu" <hjl@lucon.org>
To: Richard Henderson <rth@redhat.com>,
	Andreas Schwab <schwab@suse.de>, gcc@gcc.gnu.org
Subject: Re: Does gcc violate the ia64 ABI?
Message-ID: <20030520155854.A12371@lucon.org>
References: <20030516144401.A4222@lucon.org> <je7k8q7dc9.fsf@sykes.suse.de> <20030516152508.A4885@lucon.org> <20030517004318.GA18262@redhat.com> <20030516184522.A7603@lucon.org> <20030517181559.GA18692@redhat.com> <20030517134317.B22720@lucon.org> <20030517235928.GA18777@redhat.com>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
User-Agent: Mutt/1.2.5.1i
In-Reply-To: <20030517235928.GA18777@redhat.com>; from rth@redhat.com on Sat, May 17, 2003 at 04:59:28PM -0700
X-UIDL: 33b21163cbce51bc0cf643fe8bdb6c0a
Status: RO
Content-Length: 1157
Lines: 32

On Sat, May 17, 2003 at 04:59:28PM -0700, Richard Henderson wrote:
> 
> > BTW, Clause 'd' is in my Sept. 2000 copy of the runtime guide. It may
> > have been there for a long time. We must have missed it somehow.
> 
> Hardly conclusive.  We need to go back to at least 1998 
> to know if someone changed the ABI out from under us.
> 

March 15, 1999, version 2.4E has the same wording. Oct. 10, 1997,
version 2.3E says

---
The gp value is always valid on entry to a procedure, and must be
valid at any procedure call. At procedure exit, the gp register
must contain either the procedure own gp, or a valid gp value
remaining from a call. In other words, this register should be
treated as a scratch register across calls (that is, a call may
destroy the register), but it must be preserved and restored prior
to procedure exit if used for any purpose other than holding the gp
value. (See the rationale in Section 5.8.)
...

5.8 Rationale
...
The gp register must be preserved by the procedure from entry to exit.
At procedure return, gp must be valid (for the returning procedure).
This allows the compiler to optimize calls known to be local.
---


H.J.

From gcc-return-74745-obrien=freebsd.org@gcc.gnu.org  Tue May 20 19:13:22 2003
Delivered-To: obrien@freebsd.org
Return-Path: gcc-return-74745-obrien=freebsd.org@gcc.gnu.org
Received: from localhost
	by localhost with POP3 (fetchmail-6.2.0)
	for obrien@localhost (single-drop); Tue, 20 May 2003 19:13:22 -0700 (PDT)
Received: from mx1.FreeBSD.org (mx1.freebsd.org [216.136.204.125])
	by hub.freebsd.org (Postfix) with ESMTP id 7D46837B401
	for <obrien@freebsd.org>; Tue, 20 May 2003 19:06:55 -0700 (PDT)
Received: from sources.redhat.com (sources.redhat.com [66.187.233.205])
	by mx1.FreeBSD.org (Postfix) with SMTP id 32E9C43F93
	for <obrien@freebsd.org>; Tue, 20 May 2003 19:06:54 -0700 (PDT)
	(envelope-from gcc-return-74745-obrien=freebsd.org@gcc.gnu.org)
Received: (qmail 24422 invoked by alias); 21 May 2003 02:06:50 -0000
Mailing-List: contact gcc-help@gcc.gnu.org; run by ezmlm
Precedence: bulk
List-Unsubscribe: <mailto:gcc-unsubscribe-obrien=freebsd.org@gcc.gnu.org>
List-Archive: <http://gcc.gnu.org/ml/gcc/>
List-Post: <mailto:gcc@gcc.gnu.org>
List-Help: <http://gcc.gnu.org/ml/>
Sender: gcc-owner@gcc.gnu.org
Delivered-To: mailing list gcc@gcc.gnu.org
Received: (qmail 24267 invoked from network); 21 May 2003 02:06:46 -0000
Received: from unknown (HELO mx2.redhat.com) (66.187.237.31)
  by sources.redhat.com with SMTP; 21 May 2003 02:06:46 -0000
Received: from int-mx2.corp.redhat.com (int-mx2.corp.redhat.com [172.16.27.26])
	by mx2.redhat.com (8.11.6/8.11.6) with ESMTP id h4L1tgZ13790;
	Tue, 20 May 2003 21:55:42 -0400
Received: from potter.sfbay.redhat.com (potter.sfbay.redhat.com [172.16.27.15])
	by int-mx2.corp.redhat.com (8.11.6/8.11.6) with ESMTP id h4L26jT27138;
	Tue, 20 May 2003 22:06:45 -0400
Received: from dot.sfbay.redhat.com (dot.sfbay.redhat.com [172.16.24.7])
	by potter.sfbay.redhat.com (8.11.6/8.11.6) with ESMTP id h4L26ia13644;
	Tue, 20 May 2003 19:06:44 -0700
Received: (from rth@localhost)
	by dot.sfbay.redhat.com (8.11.6/8.11.6) id h4L24n201382;
	Tue, 20 May 2003 19:04:49 -0700
X-Authentication-Warning: dot.sfbay.redhat.com: rth set sender to rth@redhat.com using -f
Date: Tue, 20 May 2003 19:04:49 -0700
From: Richard Henderson <rth@redhat.com>
To: "H. J. Lu" <hjl@lucon.org>
Cc: Andreas Schwab <schwab@suse.de>, gcc@gcc.gnu.org
Subject: Re: Does gcc violate the ia64 ABI?
Message-ID: <20030521020449.GB1368@redhat.com>
Mail-Followup-To: Richard Henderson <rth@redhat.com>,
	"H. J. Lu" <hjl@lucon.org>, Andreas Schwab <schwab@suse.de>,
	gcc@gcc.gnu.org
References: <20030516144401.A4222@lucon.org> <je7k8q7dc9.fsf@sykes.suse.de> <20030516152508.A4885@lucon.org> <20030517004318.GA18262@redhat.com> <20030516184522.A7603@lucon.org> <20030517181559.GA18692@redhat.com> <20030517134317.B22720@lucon.org> <20030517235928.GA18777@redhat.com> <20030520155854.A12371@lucon.org>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <20030520155854.A12371@lucon.org>
User-Agent: Mutt/1.4i
X-UIDL: d855210c68418ac84943c3f908c5d114
Status: RO
Content-Length: 240
Lines: 9

On Tue, May 20, 2003 at 03:58:54PM -0700, H. J. Lu wrote:
> March 15, 1999, version 2.4E has the same wording. Oct. 10, 1997,
> version 2.3E says

Ok, we just missed it.  I guess we're going to have to 
have a flag day for gcc ia64...


r~

From gcc-return-74473-obrien=freebsd.org@gcc.gnu.org  Fri May 16 16:44:48 2003
Delivered-To: obrien@freebsd.org
Return-Path: gcc-return-74473-obrien=freebsd.org@gcc.gnu.org
Received: from localhost
	by localhost with POP3 (fetchmail-6.2.0)
	for obrien@localhost (single-drop); Fri, 16 May 2003 16:44:48 -0700 (PDT)
Received: from mx1.FreeBSD.org (mx1.freebsd.org [216.136.204.125])
	by hub.freebsd.org (Postfix) with ESMTP id 9DD4F37B401
	for <obrien@freebsd.org>; Fri, 16 May 2003 16:37:08 -0700 (PDT)
Received: from sources.redhat.com (sources.redhat.com [66.187.233.205])
	by mx1.FreeBSD.org (Postfix) with SMTP id CB30B43F3F
	for <obrien@freebsd.org>; Fri, 16 May 2003 16:37:07 -0700 (PDT)
	(envelope-from gcc-return-74473-obrien=freebsd.org@gcc.gnu.org)
Received: (qmail 7319 invoked by alias); 16 May 2003 23:37:06 -0000
Mailing-List: contact gcc-help@gcc.gnu.org; run by ezmlm
Precedence: bulk
List-Unsubscribe: <mailto:gcc-unsubscribe-obrien=freebsd.org@gcc.gnu.org>
List-Archive: <http://gcc.gnu.org/ml/gcc/>
List-Post: <mailto:gcc@gcc.gnu.org>
List-Help: <http://gcc.gnu.org/ml/>
Sender: gcc-owner@gcc.gnu.org
Delivered-To: mailing list gcc@gcc.gnu.org
Received: (qmail 7303 invoked from network); 16 May 2003 23:37:05 -0000
Received: from unknown (HELO hiauly1.hia.nrc.ca) (132.246.100.193)
  by sources.redhat.com with SMTP; 16 May 2003 23:37:05 -0000
Received: from hiauly1.hia.nrc.ca (hiauly1.hia.nrc.ca [127.0.0.1] (may be forged))
	by hiauly1.hia.nrc.ca (8.12.9/8.12.9) with ESMTP id h4GNb4gL010603;
	Fri, 16 May 2003 19:37:04 -0400 (EDT)
Received: (from dave@localhost)
	by hiauly1.hia.nrc.ca (8.12.9/8.12.9/Submit) id h4GNb3hT010602;
	Fri, 16 May 2003 19:37:03 -0400 (EDT)
Message-Id: <200305162337.h4GNb3hT010602@hiauly1.hia.nrc.ca>
Subject: Re: Does gcc violate the ia64 ABI?
To: gcc@gcc.gnu.org
Date: Fri, 16 May 2003 19:37:03 -0400 (EDT)
From: "John David Anglin" <dave@hiauly1.hia.nrc.ca>
Cc: hjl@lucon.com
MIME-Version: 1.0
Content-Type: text/plain; charset=US-ASCII
Content-Transfer-Encoding: 7bit
X-UIDL: daf8858b1646e34d69eae51dd5b764e3
Status: RO
Content-Length: 801
Lines: 26

> The problem is gcc doesn't save/store gp across call. According to the
> ia64 ABI, callee can change gp and gp must be saved/restore by caller
> across calls. It is on page 5-2 in the Itanium Software Conventions
> and Runtime Architecture Guide. Am I right?
> 
> # gcc -O2 -S x.c
> 
> H.J.
> --x.c-
> extern void foo ();
>  
>  void
>  bar (void)
>  {
>    foo ();
>  }

As on the PA, I don't believe there is a need to always save and restore
gp.  gp isn't used in bar.  The caller of bar will restore gp if it
uses gp after calling bar.  If bar called foo twice, then gp should
be saved and restored across the first call to foo.

Dave
-- 
J. David Anglin                                  dave.anglin@nrc-cnrc.gc.ca
National Research Council of Canada              (613) 990-0752 (FAX: 952-6602)

From gcc-return-74494-obrien=freebsd.org@gcc.gnu.org  Sat May 17 11:58:43 2003
Delivered-To: obrien@freebsd.org
Return-Path: gcc-return-74494-obrien=freebsd.org@gcc.gnu.org
Received: from localhost
	by localhost with POP3 (fetchmail-6.2.0)
	for obrien@localhost (single-drop); Sat, 17 May 2003 11:58:43 -0700 (PDT)
Received: from mx1.FreeBSD.org (mx1.freebsd.org [216.136.204.125])
	by hub.freebsd.org (Postfix) with ESMTP id 81ED937B401
	for <obrien@freebsd.org>; Sat, 17 May 2003 11:58:37 -0700 (PDT)
Received: from sources.redhat.com (sources.redhat.com [66.187.233.205])
	by mx1.FreeBSD.org (Postfix) with SMTP id A447143FA3
	for <obrien@freebsd.org>; Sat, 17 May 2003 11:58:36 -0700 (PDT)
	(envelope-from gcc-return-74494-obrien=freebsd.org@gcc.gnu.org)
Received: (qmail 31504 invoked by alias); 17 May 2003 18:58:34 -0000
Mailing-List: contact gcc-help@gcc.gnu.org; run by ezmlm
Precedence: bulk
List-Unsubscribe: <mailto:gcc-unsubscribe-obrien=freebsd.org@gcc.gnu.org>
List-Archive: <http://gcc.gnu.org/ml/gcc/>
List-Post: <mailto:gcc@gcc.gnu.org>
List-Help: <http://gcc.gnu.org/ml/>
Sender: gcc-owner@gcc.gnu.org
Delivered-To: mailing list gcc@gcc.gnu.org
Received: (qmail 31449 invoked from network); 17 May 2003 18:58:33 -0000
Received: from unknown (HELO hiauly1.hia.nrc.ca) (132.246.100.193)
  by sources.redhat.com with SMTP; 17 May 2003 18:58:33 -0000
Received: from hiauly1.hia.nrc.ca (hiauly1.hia.nrc.ca [127.0.0.1] (may be forged))
	by hiauly1.hia.nrc.ca (8.12.9/8.12.9) with ESMTP id h4HIwVgL014004;
	Sat, 17 May 2003 14:58:31 -0400 (EDT)
Received: (from dave@localhost)
	by hiauly1.hia.nrc.ca (8.12.9/8.12.9/Submit) id h4HIwT9t014002;
	Sat, 17 May 2003 14:58:29 -0400 (EDT)
Message-Id: <200305171858.h4HIwT9t014002@hiauly1.hia.nrc.ca>
Subject: Re: Does gcc violate the ia64 ABI?
To: gcc@gcc.gnu.org, rth@redhat.com, schwab@suse.de, hjl@lucon.org
Date: Sat, 17 May 2003 14:58:29 -0400 (EDT)
From: "John David Anglin" <dave@hiauly1.hia.nrc.ca>
MIME-Version: 1.0
Content-Type: text/plain; charset=US-ASCII
Content-Transfer-Encoding: 7bit
X-UIDL: c85d774ba36f9b58fee7f6539f3a3b05
Status: RO
Content-Length: 1722
Lines: 36

> On Fri, May 16, 2003 at 05:43:18PM -0700, Richard Henderson wrote:
> > On Fri, May 16, 2003 at 03:25:08PM -0700, H. J. Lu wrote:
> > > d. At procedure return, gp must be valid (for the returning prodecure).
> > > This allows the compiler to optimize calls known to be local (i.e., the
> > > exceptions to Rule 'c').
> > 
> > I was not aware of this clause.  I'd have sworn it wasn't a part
> > of the ABI at one time...
> > 
> > Indeed, if this clause is truely correct, then virtually all of
> > the tail-call possibilities on ia64 are invalid.  Yes, statics
> > still can be done, but that's not nearly as frequent.
> 
> Gcc can skip gp save/restore across a local call. Right now, gcc
> saves and restores gp across a local call.

Your example shows a tail-call to foo.  Gp is obviously valid at the call.
There is no return in your example, so 'd' doesn't apply.

Note that skipping the gp save/restore across a local call is a "compiler"
optimization.  If you save and restore gp across local calls, then
it's likely possible to skip the save and restore across the last call in
a function if gp is not used after the last call, including the return
path to the caller.  I don't have a good feeling as to which of these
two optimizations is more beneficial.  I would judge that the latter
treatment would be in slight violation of the ia64 ABI, but the violation
would be local to a translation unit.

We currently do the latter optimization on the pa but I am wondering
if it would be better to skip the gp save/restore across local calls
instead.

Dave
-- 
J. David Anglin                                  dave.anglin@nrc-cnrc.gc.ca
National Research Council of Canada              (613) 990-0752 (FAX: 952-6602)

From gcc-return-74497-obrien=freebsd.org@gcc.gnu.org  Sat May 17 13:35:16 2003
Delivered-To: obrien@freebsd.org
Return-Path: gcc-return-74497-obrien=freebsd.org@gcc.gnu.org
Received: from localhost
	by localhost with POP3 (fetchmail-6.2.0)
	for obrien@localhost (single-drop); Sat, 17 May 2003 13:35:16 -0700 (PDT)
Received: from mx1.FreeBSD.org (mx1.freebsd.org [216.136.204.125])
	by hub.freebsd.org (Postfix) with ESMTP id 508C537B401
	for <obrien@freebsd.org>; Sat, 17 May 2003 13:31:30 -0700 (PDT)
Received: from sources.redhat.com (sources.redhat.com [66.187.233.205])
	by mx1.FreeBSD.org (Postfix) with SMTP id 524CE43FA3
	for <obrien@freebsd.org>; Sat, 17 May 2003 13:31:29 -0700 (PDT)
	(envelope-from gcc-return-74497-obrien=freebsd.org@gcc.gnu.org)
Received: (qmail 8096 invoked by alias); 17 May 2003 20:31:28 -0000
Mailing-List: contact gcc-help@gcc.gnu.org; run by ezmlm
Precedence: bulk
List-Unsubscribe: <mailto:gcc-unsubscribe-obrien=freebsd.org@gcc.gnu.org>
List-Archive: <http://gcc.gnu.org/ml/gcc/>
List-Post: <mailto:gcc@gcc.gnu.org>
List-Help: <http://gcc.gnu.org/ml/>
Sender: gcc-owner@gcc.gnu.org
Delivered-To: mailing list gcc@gcc.gnu.org
Received: (qmail 8043 invoked from network); 17 May 2003 20:31:27 -0000
Received: from unknown (HELO sccrmhc02.attbi.com) (204.127.202.62)
  by sources.redhat.com with SMTP; 17 May 2003 20:31:27 -0000
Received: from lucon.org (12-234-88-5.client.attbi.com[12.234.88.5])
          by attbi.com (sccrmhc02) with ESMTP
          id <2003051720312700200a7sg7e>; Sat, 17 May 2003 20:31:27 +0000
Received: by lucon.org (Postfix, from userid 1000)
	id AC74F2C681; Sat, 17 May 2003 13:31:26 -0700 (PDT)
Date: Sat, 17 May 2003 13:31:26 -0700
From: "H. J. Lu" <hjl@lucon.org>
To: John David Anglin <dave@hiauly1.hia.nrc.ca>
Cc: gcc@gcc.gnu.org, rth@redhat.com, schwab@suse.de
Subject: Re: Does gcc violate the ia64 ABI?
Message-ID: <20030517133126.A22720@lucon.org>
References: <200305171858.h4HIwT9t014002@hiauly1.hia.nrc.ca>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
User-Agent: Mutt/1.2.5.1i
In-Reply-To: <200305171858.h4HIwT9t014002@hiauly1.hia.nrc.ca>; from dave@hiauly1.hia.nrc.ca on Sat, May 17, 2003 at 02:58:29PM -0400
X-UIDL: fa4d873d6812a40eaf534d899be082c0
Status: RO
Content-Length: 2004
Lines: 49

On Sat, May 17, 2003 at 02:58:29PM -0400, John David Anglin wrote:
> > On Fri, May 16, 2003 at 05:43:18PM -0700, Richard Henderson wrote:
> > > On Fri, May 16, 2003 at 03:25:08PM -0700, H. J. Lu wrote:
> > > > d. At procedure return, gp must be valid (for the returning prodecure).
> > > > This allows the compiler to optimize calls known to be local (i.e., the
> > > > exceptions to Rule 'c').
> > > 
> > > I was not aware of this clause.  I'd have sworn it wasn't a part
> > > of the ABI at one time...
> > > 
> > > Indeed, if this clause is truely correct, then virtually all of
> > > the tail-call possibilities on ia64 are invalid.  Yes, statics
> > > still can be done, but that's not nearly as frequent.
> > 
> > Gcc can skip gp save/restore across a local call. Right now, gcc
> > saves and restores gp across a local call.
> 
> Your example shows a tail-call to foo.  Gp is obviously valid at the call.
> There is no return in your example, so 'd' doesn't apply.
> 

What did you by "no return"? Where does it go?

> Note that skipping the gp save/restore across a local call is a "compiler"
> optimization.  If you save and restore gp across local calls, then
> it's likely possible to skip the save and restore across the last call in
> a function if gp is not used after the last call, including the return
> path to the caller.  I don't have a good feeling as to which of these

You don't have to save and restore gp as long as you can prove gp is
not changed. It has nothing to do if gp is used or not, according to
the ia64 psABI.

> two optimizations is more beneficial.  I would judge that the latter
> treatment would be in slight violation of the ia64 ABI, but the violation
> would be local to a translation unit.

A violation is a violation. There is no slight violation.

> 
> We currently do the latter optimization on the pa but I am wondering
> if it would be better to skip the gp save/restore across local calls
> instead.
 

 That is safe according to the ia64 psABI.


 H.J.

From gcc-return-74501-obrien=freebsd.org@gcc.gnu.org  Sat May 17 15:28:19 2003
Delivered-To: obrien@freebsd.org
Return-Path: gcc-return-74501-obrien=freebsd.org@gcc.gnu.org
Received: from localhost
	by localhost with POP3 (fetchmail-6.2.0)
	for obrien@localhost (single-drop); Sat, 17 May 2003 15:28:19 -0700 (PDT)
Received: from mx1.FreeBSD.org (mx1.freebsd.org [216.136.204.125])
	by hub.freebsd.org (Postfix) with ESMTP id CB12C37B401
	for <obrien@freebsd.org>; Sat, 17 May 2003 15:23:50 -0700 (PDT)
Received: from sources.redhat.com (sources.redhat.com [66.187.233.205])
	by mx1.FreeBSD.org (Postfix) with SMTP id E491F43FA3
	for <obrien@freebsd.org>; Sat, 17 May 2003 15:23:49 -0700 (PDT)
	(envelope-from gcc-return-74501-obrien=freebsd.org@gcc.gnu.org)
Received: (qmail 418 invoked by alias); 17 May 2003 22:23:48 -0000
Mailing-List: contact gcc-help@gcc.gnu.org; run by ezmlm
Precedence: bulk
List-Unsubscribe: <mailto:gcc-unsubscribe-obrien=freebsd.org@gcc.gnu.org>
List-Archive: <http://gcc.gnu.org/ml/gcc/>
List-Post: <mailto:gcc@gcc.gnu.org>
List-Help: <http://gcc.gnu.org/ml/>
Sender: gcc-owner@gcc.gnu.org
Delivered-To: mailing list gcc@gcc.gnu.org
Received: (qmail 382 invoked from network); 17 May 2003 22:23:48 -0000
Received: from unknown (HELO hiauly1.hia.nrc.ca) (132.246.100.193)
  by sources.redhat.com with SMTP; 17 May 2003 22:23:48 -0000
Received: from hiauly1.hia.nrc.ca (hiauly1.hia.nrc.ca [127.0.0.1] (may be forged))
	by hiauly1.hia.nrc.ca (8.12.9/8.12.9) with ESMTP id h4HMNjgL014517;
	Sat, 17 May 2003 18:23:46 -0400 (EDT)
Received: (from dave@localhost)
	by hiauly1.hia.nrc.ca (8.12.9/8.12.9/Submit) id h4HMNj3M014515;
	Sat, 17 May 2003 18:23:45 -0400 (EDT)
Message-Id: <200305172223.h4HMNj3M014515@hiauly1.hia.nrc.ca>
Subject: Re: Does gcc violate the ia64 ABI?
To: hjl@lucon.org (H. J. Lu)
Date: Sat, 17 May 2003 18:23:44 -0400 (EDT)
From: "John David Anglin" <dave@hiauly1.hia.nrc.ca>
Cc: gcc@gcc.gnu.org, rth@redhat.com, schwab@suse.de
In-Reply-To: <20030517133126.A22720@lucon.org> from "H. J. Lu" at May 17, 2003 01:31:26 pm
MIME-Version: 1.0
Content-Type: text/plain; charset=US-ASCII
Content-Transfer-Encoding: 7bit
X-UIDL: f15ccfea3c160756123f18b3629cc61e
Status: RO
Content-Length: 1645
Lines: 43

> > > Gcc can skip gp save/restore across a local call. Right now, gcc
> > > saves and restores gp across a local call.
> > 
> > Your example shows a tail-call to foo.  Gp is obviously valid at the call.
> > There is no return in your example, so 'd' doesn't apply.
> > 
> 
> What did you by "no return"? Where does it go?

The return is in "foo".  A tall call to an external function may
change gp.

> > two optimizations is more beneficial.  I would judge that the latter
> > treatment would be in slight violation of the ia64 ABI, but the violation
> > would be local to a translation unit.
> 
> A violation is a violation. There is no slight violation.

I was describing the pa treatment where there isn't similar wording
about the validity of gp at procedure return.

> > We currently do the latter optimization on the pa but I am wondering
> > if it would be better to skip the gp save/restore across local calls
> > instead.
>  
> 
>  That is safe according to the ia64 psABI.

Read carefully what 'c' says:

> c. Any procedure call (indirect or direct) may modify gp - unless the call
> is known to be local to the load module.

This is talking about what happens in a procedure call.  It's not talking
about what happens to gp in the body of a procedure.  'c' and 'd' don't
guarantee that gp won't be modified when a local call returns.  For that,
you need to know if it is valid for a function to make an external
tail call, what happens to gp in the return path, etc.

Dave
-- 
J. David Anglin                                  dave.anglin@nrc-cnrc.gc.ca
National Research Council of Canada              (613) 990-0752 (FAX: 952-6602)

From gcc-return-74503-obrien=freebsd.org@gcc.gnu.org  Sat May 17 16:48:52 2003
Delivered-To: obrien@freebsd.org
Return-Path: gcc-return-74503-obrien=freebsd.org@gcc.gnu.org
Received: from localhost
	by localhost with POP3 (fetchmail-6.2.0)
	for obrien@localhost (single-drop); Sat, 17 May 2003 16:48:52 -0700 (PDT)
Received: from mx1.FreeBSD.org (mx1.freebsd.org [216.136.204.125])
	by hub.freebsd.org (Postfix) with ESMTP id 72F8637B401
	for <obrien@freebsd.org>; Sat, 17 May 2003 16:42:16 -0700 (PDT)
Received: from sources.redhat.com (sources.redhat.com [66.187.233.205])
	by mx1.FreeBSD.org (Postfix) with SMTP id 8AF3743F93
	for <obrien@freebsd.org>; Sat, 17 May 2003 16:42:15 -0700 (PDT)
	(envelope-from gcc-return-74503-obrien=freebsd.org@gcc.gnu.org)
Received: (qmail 5452 invoked by alias); 17 May 2003 23:42:14 -0000
Mailing-List: contact gcc-help@gcc.gnu.org; run by ezmlm
Precedence: bulk
List-Unsubscribe: <mailto:gcc-unsubscribe-obrien=freebsd.org@gcc.gnu.org>
List-Archive: <http://gcc.gnu.org/ml/gcc/>
List-Post: <mailto:gcc@gcc.gnu.org>
List-Help: <http://gcc.gnu.org/ml/>
Sender: gcc-owner@gcc.gnu.org
Delivered-To: mailing list gcc@gcc.gnu.org
Received: (qmail 5412 invoked from network); 17 May 2003 23:42:13 -0000
Received: from unknown (HELO rwcrmhc52.attbi.com) (216.148.227.88)
  by sources.redhat.com with SMTP; 17 May 2003 23:42:13 -0000
Received: from lucon.org (12-234-88-5.client.attbi.com[12.234.88.5])
          by attbi.com (rwcrmhc52) with ESMTP
          id <2003051723421305200o45g7e>; Sat, 17 May 2003 23:42:13 +0000
Received: by lucon.org (Postfix, from userid 1000)
	id 01DA22C683; Sat, 17 May 2003 16:42:12 -0700 (PDT)
Date: Sat, 17 May 2003 16:42:12 -0700
From: "H. J. Lu" <hjl@lucon.org>
To: John David Anglin <dave@hiauly1.hia.nrc.ca>
Cc: gcc@gcc.gnu.org, rth@redhat.com, schwab@suse.de
Subject: Re: Does gcc violate the ia64 ABI?
Message-ID: <20030517164212.A25391@lucon.org>
References: <20030517133126.A22720@lucon.org> <200305172223.h4HMNj3M014515@hiauly1.hia.nrc.ca>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
User-Agent: Mutt/1.2.5.1i
In-Reply-To: <200305172223.h4HMNj3M014515@hiauly1.hia.nrc.ca>; from dave@hiauly1.hia.nrc.ca on Sat, May 17, 2003 at 06:23:44PM -0400
X-UIDL: 94f37a49b4e19f981b44c61c935424df
Status: RO
Content-Length: 932
Lines: 26

On Sat, May 17, 2003 at 06:23:44PM -0400, John David Anglin wrote:
> >  
> > 
> >  That is safe according to the ia64 psABI.
> 
> Read carefully what 'c' says:
> 
> > c. Any procedure call (indirect or direct) may modify gp - unless the call
> > is known to be local to the load module.
> 
> This is talking about what happens in a procedure call.  It's not talking
> about what happens to gp in the body of a procedure.  'c' and 'd' don't
> guarantee that gp won't be modified when a local call returns.  For that,

'c' and 'd' require the compiler guarantees gp won't be modified when
a local call returns since gp will be the same at procedure entry and
exit.

> you need to know if it is valid for a function to make an external
> tail call, what happens to gp in the return path, etc.

Basically, an ia64 psABI conforming compiler should save/restore gp
across an external call no matter if gp is used by caller or not.


H.J.

From gcc-return-74508-obrien=freebsd.org@gcc.gnu.org  Sat May 17 20:17:58 2003
Delivered-To: obrien@freebsd.org
Return-Path: gcc-return-74508-obrien=freebsd.org@gcc.gnu.org
Received: from localhost
	by localhost with POP3 (fetchmail-6.2.0)
	for obrien@localhost (single-drop); Sat, 17 May 2003 20:17:58 -0700 (PDT)
Received: from mx1.FreeBSD.org (mx1.freebsd.org [216.136.204.125])
	by hub.freebsd.org (Postfix) with ESMTP id 8A87B37B401
	for <obrien@freebsd.org>; Sat, 17 May 2003 20:10:22 -0700 (PDT)
Received: from sources.redhat.com (sources.redhat.com [66.187.233.205])
	by mx1.FreeBSD.org (Postfix) with SMTP id A803A43F85
	for <obrien@freebsd.org>; Sat, 17 May 2003 20:10:21 -0700 (PDT)
	(envelope-from gcc-return-74508-obrien=freebsd.org@gcc.gnu.org)
Received: (qmail 32060 invoked by alias); 18 May 2003 03:10:20 -0000
Mailing-List: contact gcc-help@gcc.gnu.org; run by ezmlm
Precedence: bulk
List-Unsubscribe: <mailto:gcc-unsubscribe-obrien=freebsd.org@gcc.gnu.org>
List-Archive: <http://gcc.gnu.org/ml/gcc/>
List-Post: <mailto:gcc@gcc.gnu.org>
List-Help: <http://gcc.gnu.org/ml/>
Sender: gcc-owner@gcc.gnu.org
Delivered-To: mailing list gcc@gcc.gnu.org
Received: (qmail 32053 invoked from network); 18 May 2003 03:10:20 -0000
Received: from unknown (HELO hiauly1.hia.nrc.ca) (132.246.100.193)
  by sources.redhat.com with SMTP; 18 May 2003 03:10:20 -0000
Received: from hiauly1.hia.nrc.ca (hiauly1.hia.nrc.ca [127.0.0.1] (may be forged))
	by hiauly1.hia.nrc.ca (8.12.9/8.12.9) with ESMTP id h4I3AIgL015129;
	Sat, 17 May 2003 23:10:18 -0400 (EDT)
Received: (from dave@localhost)
	by hiauly1.hia.nrc.ca (8.12.9/8.12.9/Submit) id h4I3AHYu015127;
	Sat, 17 May 2003 23:10:17 -0400 (EDT)
Message-Id: <200305180310.h4I3AHYu015127@hiauly1.hia.nrc.ca>
Subject: Re: Does gcc violate the ia64 ABI?
To: hjl@lucon.org (H. J. Lu)
Date: Sat, 17 May 2003 23:10:17 -0400 (EDT)
From: "John David Anglin" <dave@hiauly1.hia.nrc.ca>
Cc: gcc@gcc.gnu.org, rth@redhat.com, schwab@suse.de
In-Reply-To: <20030517164212.A25391@lucon.org> from "H. J. Lu" at May 17, 2003 04:42:12 pm
MIME-Version: 1.0
Content-Type: text/plain; charset=US-ASCII
Content-Transfer-Encoding: 7bit
X-UIDL: af93b213817003886505950f4b0bedfd
Status: RO
Content-Length: 1296
Lines: 26

> > This is talking about what happens in a procedure call.  It's not talking
> > about what happens to gp in the body of a procedure.  'c' and 'd' don't
> > guarantee that gp won't be modified when a local call returns.  For that,
> 
> 'c' and 'd' require the compiler guarantees gp won't be modified when
> a local call returns since gp will be the same at procedure entry and
> exit.

That's not how I interpret them.  They say that gp will be valid at
procedure entry and at procedure return.  The returning procedure is
not bar if it does a tail call to another procedure.  So, I can't
see how you can argue that gp always will be preserved across local
calls if tail calls are ok.

The last sentence in 'd' is not a requirement.  The same compiler
does both the tail call optimization and the local call optimization.
So, it can decide to perform one or the other, or none in situations
where there is an incompatibility.  I don't see that not being able
to optimize calls known to be local is an ABI violation.  Generating
tail calls might be an ABI violation but again I can't see how 'a' to
'd' explicitly rule them out.

Dave
-- 
J. David Anglin                                  dave.anglin@nrc-cnrc.gc.ca
National Research Council of Canada              (613) 990-0752 (FAX: 952-6602)

From gcc-return-74509-obrien=freebsd.org@gcc.gnu.org  Sat May 17 20:26:00 2003
Delivered-To: obrien@freebsd.org
Return-Path: gcc-return-74509-obrien=freebsd.org@gcc.gnu.org
Received: from localhost
	by localhost with POP3 (fetchmail-6.2.0)
	for obrien@localhost (single-drop); Sat, 17 May 2003 20:26:00 -0700 (PDT)
Received: from mx1.FreeBSD.org (mx1.freebsd.org [216.136.204.125])
	by hub.freebsd.org (Postfix) with ESMTP id 2660E37B401
	for <obrien@freebsd.org>; Sat, 17 May 2003 20:22:38 -0700 (PDT)
Received: from sources.redhat.com (sources.redhat.com [66.187.233.205])
	by mx1.FreeBSD.org (Postfix) with SMTP id 3980443FAF
	for <obrien@freebsd.org>; Sat, 17 May 2003 20:22:37 -0700 (PDT)
	(envelope-from gcc-return-74509-obrien=freebsd.org@gcc.gnu.org)
Received: (qmail 27193 invoked by alias); 18 May 2003 03:22:35 -0000
Mailing-List: contact gcc-help@gcc.gnu.org; run by ezmlm
Precedence: bulk
List-Unsubscribe: <mailto:gcc-unsubscribe-obrien=freebsd.org@gcc.gnu.org>
List-Archive: <http://gcc.gnu.org/ml/gcc/>
List-Post: <mailto:gcc@gcc.gnu.org>
List-Help: <http://gcc.gnu.org/ml/>
Sender: gcc-owner@gcc.gnu.org
Delivered-To: mailing list gcc@gcc.gnu.org
Received: (qmail 27160 invoked from network); 18 May 2003 03:22:35 -0000
Received: from unknown (HELO sccrmhc01.attbi.com) (204.127.202.61)
  by sources.redhat.com with SMTP; 18 May 2003 03:22:35 -0000
Received: from lucon.org (12-234-88-5.client.attbi.com[12.234.88.5])
          by attbi.com (sccrmhc01) with ESMTP
          id <2003051803223400100g5tt7e>; Sun, 18 May 2003 03:22:34 +0000
Received: by lucon.org (Postfix, from userid 1000)
	id 895562C683; Sat, 17 May 2003 20:22:34 -0700 (PDT)
Date: Sat, 17 May 2003 20:22:34 -0700
From: "H. J. Lu" <hjl@lucon.org>
To: John David Anglin <dave@hiauly1.hia.nrc.ca>
Cc: gcc@gcc.gnu.org, rth@redhat.com, schwab@suse.de
Subject: Re: Does gcc violate the ia64 ABI?
Message-ID: <20030517202234.A28227@lucon.org>
References: <20030517164212.A25391@lucon.org> <200305180310.h4I3AHYu015127@hiauly1.hia.nrc.ca>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
User-Agent: Mutt/1.2.5.1i
In-Reply-To: <200305180310.h4I3AHYu015127@hiauly1.hia.nrc.ca>; from dave@hiauly1.hia.nrc.ca on Sat, May 17, 2003 at 11:10:17PM -0400
X-UIDL: abafc007766d935e4ced0efe2ad1beaa
Status: RO
Content-Length: 1853
Lines: 43

On Sat, May 17, 2003 at 11:10:17PM -0400, John David Anglin wrote:
> > > This is talking about what happens in a procedure call.  It's not talking
> > > about what happens to gp in the body of a procedure.  'c' and 'd' don't
> > > guarantee that gp won't be modified when a local call returns.  For that,
> > 
> > 'c' and 'd' require the compiler guarantees gp won't be modified when
> > a local call returns since gp will be the same at procedure entry and
> > exit.
> 
> That's not how I interpret them.  They say that gp will be valid at
> procedure entry and at procedure return.  The returning procedure is
> not bar if it does a tail call to another procedure.  So, I can't

Where did the psABI say that? You can't interpret something which is
is not there. Any procedure is a returning procedure, bar is included.

> see how you can argue that gp always will be preserved across local
> calls if tail calls are ok.
> 
> The last sentence in 'd' is not a requirement.  The same compiler

I was talking about the "At procedure return, gp must be valid." part.

> does both the tail call optimization and the local call optimization.
> So, it can decide to perform one or the other, or none in situations
> where there is an incompatibility.  I don't see that not being able
> to optimize calls known to be local is an ABI violation.  Generating
> tail calls might be an ABI violation but again I can't see how 'a' to
> 'd' explicitly rule them out.

The rule says gp much be valid at entry and exit, period. It states

---
The effect of the rules is that gp must be treated as scratch register
at the point of call (i.e., it must be saved by the caller), and it must
be preserved from entry to exit.
---

The only optimization allowed by the ia64 psABI is to skip save/restore
gp across a function call if you can prove gp won't be changed.


H.J.

From gcc-return-74546-obrien=freebsd.org@gcc.gnu.org  Sun May 18 15:57:17 2003
Delivered-To: obrien@freebsd.org
Return-Path: gcc-return-74546-obrien=freebsd.org@gcc.gnu.org
Received: from localhost
	by localhost with POP3 (fetchmail-6.2.0)
	for obrien@localhost (single-drop); Sun, 18 May 2003 15:57:17 -0700 (PDT)
Received: from mx1.FreeBSD.org (mx1.freebsd.org [216.136.204.125])
	by hub.freebsd.org (Postfix) with ESMTP id C1C6937B407
	for <obrien@freebsd.org>; Sun, 18 May 2003 15:52:00 -0700 (PDT)
Received: from sources.redhat.com (sources.redhat.com [66.187.233.205])
	by mx1.FreeBSD.org (Postfix) with SMTP id 6E33E43FA3
	for <obrien@freebsd.org>; Sun, 18 May 2003 15:51:59 -0700 (PDT)
	(envelope-from gcc-return-74546-obrien=freebsd.org@gcc.gnu.org)
Received: (qmail 14183 invoked by alias); 18 May 2003 22:51:58 -0000
Mailing-List: contact gcc-help@gcc.gnu.org; run by ezmlm
Precedence: bulk
List-Unsubscribe: <mailto:gcc-unsubscribe-obrien=freebsd.org@gcc.gnu.org>
List-Archive: <http://gcc.gnu.org/ml/gcc/>
List-Post: <mailto:gcc@gcc.gnu.org>
List-Help: <http://gcc.gnu.org/ml/>
Sender: gcc-owner@gcc.gnu.org
Delivered-To: mailing list gcc@gcc.gnu.org
Received: (qmail 14122 invoked from network); 18 May 2003 22:51:57 -0000
Received: from unknown (HELO hiauly1.hia.nrc.ca) (132.246.100.193)
  by sources.redhat.com with SMTP; 18 May 2003 22:51:57 -0000
Received: from hiauly1.hia.nrc.ca (hiauly1.hia.nrc.ca [127.0.0.1] (may be forged))
	by hiauly1.hia.nrc.ca (8.12.9/8.12.9) with ESMTP id h4IMpugL017881;
	Sun, 18 May 2003 18:51:56 -0400 (EDT)
Received: (from dave@localhost)
	by hiauly1.hia.nrc.ca (8.12.9/8.12.9/Submit) id h4IMpsCD017880;
	Sun, 18 May 2003 18:51:54 -0400 (EDT)
Message-Id: <200305182251.h4IMpsCD017880@hiauly1.hia.nrc.ca>
Subject: Re: Does gcc violate the ia64 ABI?
To: hjl@lucon.org (H. J. Lu)
Date: Sun, 18 May 2003 18:51:54 -0400 (EDT)
From: "John David Anglin" <dave@hiauly1.hia.nrc.ca>
Cc: gcc@gcc.gnu.org, rth@redhat.com, schwab@suse.de
In-Reply-To: <20030517202234.A28227@lucon.org> from "H. J. Lu" at May 17, 2003 08:22:34 pm
MIME-Version: 1.0
Content-Type: text/plain; charset=US-ASCII
Content-Transfer-Encoding: 7bit
X-UIDL: ede2d05a740a185a93fd2ef620da3219
Status: RO
Content-Length: 655
Lines: 17

> The rule says gp much be valid at entry and exit, period. It states
> 
> ---
> The effect of the rules is that gp must be treated as scratch register
> at the point of call (i.e., it must be saved by the caller), and it must
> be preserved from entry to exit.

> A violation is a violation. There is no slight violation.

Okay officer you got me, don't shoot!  You already got me in the leg.
I promise I won't do any more of those nasty tail calls, use thunks or
jump on trampolines ...

Dave
-- 
J. David Anglin                                  dave.anglin@nrc-cnrc.gc.ca
National Research Council of Canada              (613) 990-0752 (FAX: 952-6602)

From gcc-return-74554-obrien=freebsd.org@gcc.gnu.org  Sun May 18 20:02:57 2003
Delivered-To: obrien@freebsd.org
Return-Path: gcc-return-74554-obrien=freebsd.org@gcc.gnu.org
Received: from localhost
	by localhost with POP3 (fetchmail-6.2.0)
	for obrien@localhost (single-drop); Sun, 18 May 2003 20:02:57 -0700 (PDT)
Received: from mx1.FreeBSD.org (mx1.freebsd.org [216.136.204.125])
	by hub.freebsd.org (Postfix) with ESMTP id 0029A37B401
	for <obrien@freebsd.org>; Sun, 18 May 2003 20:01:54 -0700 (PDT)
Received: from sources.redhat.com (sources.redhat.com [66.187.233.205])
	by mx1.FreeBSD.org (Postfix) with SMTP id 1A42143FAF
	for <obrien@freebsd.org>; Sun, 18 May 2003 20:01:54 -0700 (PDT)
	(envelope-from gcc-return-74554-obrien=freebsd.org@gcc.gnu.org)
Received: (qmail 5147 invoked by alias); 19 May 2003 03:01:51 -0000
Mailing-List: contact gcc-help@gcc.gnu.org; run by ezmlm
Precedence: bulk
List-Unsubscribe: <mailto:gcc-unsubscribe-obrien=freebsd.org@gcc.gnu.org>
List-Archive: <http://gcc.gnu.org/ml/gcc/>
List-Post: <mailto:gcc@gcc.gnu.org>
List-Help: <http://gcc.gnu.org/ml/>
Sender: gcc-owner@gcc.gnu.org
Delivered-To: mailing list gcc@gcc.gnu.org
Received: (qmail 5129 invoked from network); 19 May 2003 03:01:50 -0000
Received: from unknown (HELO mulga.cs.mu.OZ.AU) (128.250.1.22)
  by sources.redhat.com with SMTP; 19 May 2003 03:01:50 -0000
Received: from ceres.cs.mu.oz.au (mail@ceres.cs.mu.OZ.AU [128.250.33.10]) by mulga.cs.mu.OZ.AU with ESMTP
	id NAA22624; Mon, 19 May 2003 13:01:39 +1000 (EST)
Received: from fjh by ceres.cs.mu.oz.au with local (Exim 3.35 #1 (Debian))
	id 19HauB-0006Oa-00; Mon, 19 May 2003 13:01:39 +1000
Date: Mon, 19 May 2003 13:01:39 +1000
From: Fergus Henderson <fjh@cs.mu.OZ.AU>
To: John David Anglin <dave@hiauly1.hia.nrc.ca>
Cc: "H. J. Lu" <hjl@lucon.org>, gcc@gcc.gnu.org, rth@redhat.com,
	schwab@suse.de
Subject: Re: Does gcc violate the ia64 ABI?
Message-ID: <20030519030139.GA23221@ceres.cs.mu.oz.au>
References: <20030517202234.A28227@lucon.org> <200305182251.h4IMpsCD017880@hiauly1.hia.nrc.ca>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <200305182251.h4IMpsCD017880@hiauly1.hia.nrc.ca>
User-Agent: Mutt/1.3.28i
X-UIDL: 134f64cbb64f57d44120c9059034b2d6
Status: RO
Content-Length: 912
Lines: 21

On 18-May-2003, John David Anglin <dave@hiauly1.hia.nrc.ca> wrote:
> > The rule says gp much be valid at entry and exit, period. It states
> > 
> > ---
> > The effect of the rules is that gp must be treated as scratch register
> > at the point of call (i.e., it must be saved by the caller), and it must
> > be preserved from entry to exit.
> 
> > A violation is a violation. There is no slight violation.
> 
> Okay officer you got me, don't shoot!  You already got me in the leg.
> I promise I won't do any more of those nasty tail calls, use thunks or
> jump on trampolines ...

If the ABI can't support tail calls, then I'd say the ABI is broken,
and should be replaced, not GCC.

-- 
Fergus Henderson <fjh@cs.mu.oz.au>  |  "I have always known that the pursuit
The University of Melbourne         |  of excellence is a lethal habit"
WWW: <http://www.cs.mu.oz.au/~fjh>  |     -- the last words of T. S. Garp.

From gcc-return-74559-obrien=freebsd.org@gcc.gnu.org  Sun May 18 22:43:59 2003
Delivered-To: obrien@freebsd.org
Return-Path: gcc-return-74559-obrien=freebsd.org@gcc.gnu.org
Received: from localhost
	by localhost with POP3 (fetchmail-6.2.0)
	for obrien@localhost (single-drop); Sun, 18 May 2003 22:43:59 -0700 (PDT)
Received: from mx1.FreeBSD.org (mx1.freebsd.org [216.136.204.125])
	by hub.freebsd.org (Postfix) with ESMTP id 64F6F37B401
	for <obrien@freebsd.org>; Sun, 18 May 2003 22:42:48 -0700 (PDT)
Received: from sources.redhat.com (sources.redhat.com [66.187.233.205])
	by mx1.FreeBSD.org (Postfix) with SMTP id 4B50143F75
	for <obrien@freebsd.org>; Sun, 18 May 2003 22:42:47 -0700 (PDT)
	(envelope-from gcc-return-74559-obrien=freebsd.org@gcc.gnu.org)
Received: (qmail 1006 invoked by alias); 19 May 2003 05:42:18 -0000
Mailing-List: contact gcc-help@gcc.gnu.org; run by ezmlm
Precedence: bulk
List-Unsubscribe: <mailto:gcc-unsubscribe-obrien=freebsd.org@gcc.gnu.org>
List-Archive: <http://gcc.gnu.org/ml/gcc/>
List-Post: <mailto:gcc@gcc.gnu.org>
List-Help: <http://gcc.gnu.org/ml/>
Sender: gcc-owner@gcc.gnu.org
Delivered-To: mailing list gcc@gcc.gnu.org
Received: (qmail 32665 invoked from network); 19 May 2003 05:41:30 -0000
Received: from unknown (HELO mx2.redhat.com) (66.187.237.31)
  by sources.redhat.com with SMTP; 19 May 2003 05:41:30 -0000
Received: from int-mx2.corp.redhat.com (int-mx2.corp.redhat.com [172.16.27.26])
	by mx2.redhat.com (8.11.6/8.11.6) with ESMTP id h4J5USZ00802;
	Mon, 19 May 2003 01:30:28 -0400
Received: from potter.sfbay.redhat.com (potter.sfbay.redhat.com [172.16.27.15])
	by int-mx2.corp.redhat.com (8.11.6/8.11.6) with ESMTP id h4J5fRT13687;
	Mon, 19 May 2003 01:41:27 -0400
Received: from dot.sfbay.redhat.com (dot.sfbay.redhat.com [172.16.24.7])
	by potter.sfbay.redhat.com (8.11.6/8.11.6) with ESMTP id h4J5fQM28369;
	Sun, 18 May 2003 22:41:26 -0700
Received: (from rth@localhost)
	by dot.sfbay.redhat.com (8.11.6/8.11.6) id h4J5cu125085;
	Sun, 18 May 2003 22:38:56 -0700
X-Authentication-Warning: dot.sfbay.redhat.com: rth set sender to rth@redhat.com using -f
Date: Sun, 18 May 2003 22:38:55 -0700
From: Richard Henderson <rth@redhat.com>
To: Fergus Henderson <fjh@cs.mu.oz.au>
Cc: John David Anglin <dave@hiauly1.hia.nrc.ca>,
	"H. J. Lu" <hjl@lucon.org>, gcc@gcc.gnu.org, schwab@suse.de
Subject: Re: Does gcc violate the ia64 ABI?
Message-ID: <20030519053855.GA25079@redhat.com>
Mail-Followup-To: Richard Henderson <rth@redhat.com>,
	Fergus Henderson <fjh@cs.mu.oz.au>,
	John David Anglin <dave@hiauly1.hia.nrc.ca>,
	"H. J. Lu" <hjl@lucon.org>, gcc@gcc.gnu.org, schwab@suse.de
References: <20030517202234.A28227@lucon.org> <200305182251.h4IMpsCD017880@hiauly1.hia.nrc.ca> <20030519030139.GA23221@ceres.cs.mu.oz.au>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <20030519030139.GA23221@ceres.cs.mu.oz.au>
User-Agent: Mutt/1.4i
X-UIDL: 2a1711d78bcbf58c90e02a3ada1931e2
Status: RO
Content-Length: 313
Lines: 10

On Mon, May 19, 2003 at 01:01:39PM +1000, Fergus Henderson wrote:
> If the ABI can't support tail calls, then I'd say the ABI is broken,
> and should be replaced, not GCC.

Only tail calls to provably local functions, apparently.
I think that's pretty stupid, considering how cheap it is
to reload the gp...


r~

From gcc-return-74588-obrien=freebsd.org@gcc.gnu.org  Mon May 19 08:01:08 2003
Delivered-To: obrien@freebsd.org
Return-Path: gcc-return-74588-obrien=freebsd.org@gcc.gnu.org
Received: from localhost
	by localhost with POP3 (fetchmail-6.2.0)
	for obrien@localhost (single-drop); Mon, 19 May 2003 08:01:08 -0700 (PDT)
Received: from mx1.FreeBSD.org (mx1.freebsd.org [216.136.204.125])
	by hub.freebsd.org (Postfix) with ESMTP id 29DD537B401
	for <obrien@freebsd.org>; Mon, 19 May 2003 07:55:44 -0700 (PDT)
Received: from sources.redhat.com (sources.redhat.com [66.187.233.205])
	by mx1.FreeBSD.org (Postfix) with SMTP id 38BD643F93
	for <obrien@freebsd.org>; Mon, 19 May 2003 07:55:43 -0700 (PDT)
	(envelope-from gcc-return-74588-obrien=freebsd.org@gcc.gnu.org)
Received: (qmail 25962 invoked by alias); 19 May 2003 14:55:42 -0000
Mailing-List: contact gcc-help@gcc.gnu.org; run by ezmlm
Precedence: bulk
List-Unsubscribe: <mailto:gcc-unsubscribe-obrien=freebsd.org@gcc.gnu.org>
List-Archive: <http://gcc.gnu.org/ml/gcc/>
List-Post: <mailto:gcc@gcc.gnu.org>
List-Help: <http://gcc.gnu.org/ml/>
Sender: gcc-owner@gcc.gnu.org
Delivered-To: mailing list gcc@gcc.gnu.org
Received: (qmail 25931 invoked from network); 19 May 2003 14:55:41 -0000
Received: from unknown (HELO rwcrmhc52.attbi.com) (216.148.227.88)
  by sources.redhat.com with SMTP; 19 May 2003 14:55:41 -0000
Received: from lucon.org (12-234-88-5.client.attbi.com[12.234.88.5])
          by attbi.com (rwcrmhc52) with ESMTP
          id <2003051914554105200ab5ele>; Mon, 19 May 2003 14:55:41 +0000
Received: by lucon.org (Postfix, from userid 1000)
	id 5A5002C681; Mon, 19 May 2003 07:55:40 -0700 (PDT)
Date: Mon, 19 May 2003 07:55:40 -0700
From: "H. J. Lu" <hjl@lucon.org>
To: Richard Henderson <rth@redhat.com>,
	Fergus Henderson <fjh@cs.mu.oz.au>,
	John David Anglin <dave@hiauly1.hia.nrc.ca>, gcc@gcc.gnu.org,
	schwab@suse.de
Subject: Re: Does gcc violate the ia64 ABI?
Message-ID: <20030519075540.A17193@lucon.org>
References: <20030517202234.A28227@lucon.org> <200305182251.h4IMpsCD017880@hiauly1.hia.nrc.ca> <20030519030139.GA23221@ceres.cs.mu.oz.au> <20030519053855.GA25079@redhat.com>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
User-Agent: Mutt/1.2.5.1i
In-Reply-To: <20030519053855.GA25079@redhat.com>; from rth@redhat.com on Sun, May 18, 2003 at 10:38:55PM -0700
X-UIDL: df69f599037b4a2148f0622bfac98f9f
Status: RO
Content-Length: 1007
Lines: 46

On Sun, May 18, 2003 at 10:38:55PM -0700, Richard Henderson wrote:
> On Mon, May 19, 2003 at 01:01:39PM +1000, Fergus Henderson wrote:
> > If the ABI can't support tail calls, then I'd say the ABI is broken,
> > and should be replaced, not GCC.
> 
> Only tail calls to provably local functions, apparently.
> I think that's pretty stupid, considering how cheap it is
> to reload the gp...

I disagree. Gcc can still do tail calls to external functions as long
as it reloads gp, which gcc is already doing when gp is used after
the call, like in this code

---
extern void bar ();

static void
bar1 ()
{
  bar ();
}

extern int x;

void
foo ()
{
  bar1 ();
  x += 1;
}
---

I think we just need to change the code from

	reload_gp = gp is used after the tail call

to

	reload_gp = the tail call is external

It may be a win since we won't reload gp for the local call even if
gp is used after the tail call. Besides, you have said reloading gp
is cheap. I don't see fixing gcc will hurt performance.


H.J.

From gcc-return-74590-obrien=freebsd.org@gcc.gnu.org  Mon May 19 08:09:11 2003
Delivered-To: obrien@freebsd.org
Return-Path: gcc-return-74590-obrien=freebsd.org@gcc.gnu.org
Received: from localhost
	by localhost with POP3 (fetchmail-6.2.0)
	for obrien@localhost (single-drop); Mon, 19 May 2003 08:09:11 -0700 (PDT)
Received: from mx1.FreeBSD.org (mx1.freebsd.org [216.136.204.125])
	by hub.freebsd.org (Postfix) with ESMTP id 98F1237B401
	for <obrien@freebsd.org>; Mon, 19 May 2003 08:02:52 -0700 (PDT)
Received: from sources.redhat.com (sources.redhat.com [66.187.233.205])
	by mx1.FreeBSD.org (Postfix) with SMTP id 957F143F3F
	for <obrien@freebsd.org>; Mon, 19 May 2003 08:02:51 -0700 (PDT)
	(envelope-from gcc-return-74590-obrien=freebsd.org@gcc.gnu.org)
Received: (qmail 10033 invoked by alias); 19 May 2003 15:02:09 -0000
Mailing-List: contact gcc-help@gcc.gnu.org; run by ezmlm
Precedence: bulk
List-Unsubscribe: <mailto:gcc-unsubscribe-obrien=freebsd.org@gcc.gnu.org>
List-Archive: <http://gcc.gnu.org/ml/gcc/>
List-Post: <mailto:gcc@gcc.gnu.org>
List-Help: <http://gcc.gnu.org/ml/>
Sender: gcc-owner@gcc.gnu.org
Delivered-To: mailing list gcc@gcc.gnu.org
Received: (qmail 9989 invoked from network); 19 May 2003 15:02:08 -0000
Received: from unknown (HELO localhost.localdomain) (195.113.19.66)
  by sources.redhat.com with SMTP; 19 May 2003 15:02:08 -0000
Received: from sunsite.ms.mff.cuni.cz (sunsite.mff.cuni.cz [127.0.0.1])
	by localhost.localdomain (8.12.8/8.12.8) with ESMTP id h4JF21qO001512;
	Mon, 19 May 2003 17:02:01 +0200
Received: (from jakub@localhost)
	by sunsite.ms.mff.cuni.cz (8.12.8/8.12.8/Submit) id h4JF21LM001506;
	Mon, 19 May 2003 17:02:01 +0200
Date: Mon, 19 May 2003 17:02:00 +0200
From: Jakub Jelinek <jakub@redhat.com>
To: "H. J. Lu" <hjl@lucon.org>
Cc: Richard Henderson <rth@redhat.com>,
	Fergus Henderson <fjh@cs.mu.oz.au>,
	John David Anglin <dave@hiauly1.hia.nrc.ca>, gcc@gcc.gnu.org,
	schwab@suse.de
Subject: Re: Does gcc violate the ia64 ABI?
Message-ID: <20030519150200.GB16629@sunsite.ms.mff.cuni.cz>
Old-Reply-To: Jakub Jelinek <jakub@redhat.com>
References: <20030517202234.A28227@lucon.org> <200305182251.h4IMpsCD017880@hiauly1.hia.nrc.ca> <20030519030139.GA23221@ceres.cs.mu.oz.au> <20030519053855.GA25079@redhat.com> <20030519075540.A17193@lucon.org>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <20030519075540.A17193@lucon.org>
User-Agent: Mutt/1.4i
X-UIDL: c5d406b0649f663a34cf2f086e0f51c8
Status: RO
Content-Length: 1042
Lines: 44

On Mon, May 19, 2003 at 07:55:40AM -0700, H. J. Lu wrote:
> > Only tail calls to provably local functions, apparently.
> > I think that's pretty stupid, considering how cheap it is
> > to reload the gp...
> 
> I disagree. Gcc can still do tail calls to external functions as long
> as it reloads gp, which gcc is already doing when gp is used after
> the call, like in this code
> 
> ---
> extern void bar ();
> 
> static void
> bar1 ()
> {
>   bar ();
> }
> 
> extern int x;
> 
> void
> foo ()
> {
>   bar1 ();
>   x += 1;
> }
> ---
> 
> I think we just need to change the code from
> 
> 	reload_gp = gp is used after the tail call
> 
> to
> 
> 	reload_gp = the tail call is external
> 
> It may be a win since we won't reload gp for the local call even if
> gp is used after the tail call. Besides, you have said reloading gp
> is cheap. I don't see fixing gcc will hurt performance.

If bar1 has to reload gp after bar returns, then certainly the call to bar
cannot be a tail call (as a tail call returns from bar stright to foo).

	Jakub

From gcc-return-74593-obrien=freebsd.org@gcc.gnu.org  Mon May 19 08:17:15 2003
Delivered-To: obrien@freebsd.org
Return-Path: gcc-return-74593-obrien=freebsd.org@gcc.gnu.org
Received: from localhost
	by localhost with POP3 (fetchmail-6.2.0)
	for obrien@localhost (single-drop); Mon, 19 May 2003 08:17:15 -0700 (PDT)
Received: from mx1.FreeBSD.org (mx1.freebsd.org [216.136.204.125])
	by hub.freebsd.org (Postfix) with ESMTP id 9607837B401
	for <obrien@freebsd.org>; Mon, 19 May 2003 08:10:35 -0700 (PDT)
Received: from sources.redhat.com (sources.redhat.com [66.187.233.205])
	by mx1.FreeBSD.org (Postfix) with SMTP id 9184443F3F
	for <obrien@freebsd.org>; Mon, 19 May 2003 08:10:34 -0700 (PDT)
	(envelope-from gcc-return-74593-obrien=freebsd.org@gcc.gnu.org)
Received: (qmail 1042 invoked by alias); 19 May 2003 15:10:24 -0000
Mailing-List: contact gcc-help@gcc.gnu.org; run by ezmlm
Precedence: bulk
List-Unsubscribe: <mailto:gcc-unsubscribe-obrien=freebsd.org@gcc.gnu.org>
List-Archive: <http://gcc.gnu.org/ml/gcc/>
List-Post: <mailto:gcc@gcc.gnu.org>
List-Help: <http://gcc.gnu.org/ml/>
Sender: gcc-owner@gcc.gnu.org
Delivered-To: mailing list gcc@gcc.gnu.org
Received: (qmail 1026 invoked from network); 19 May 2003 15:10:23 -0000
Received: from unknown (HELO sccrmhc02.attbi.com) (204.127.202.62)
  by sources.redhat.com with SMTP; 19 May 2003 15:10:23 -0000
Received: from lucon.org (12-234-88-5.client.attbi.com[12.234.88.5])
          by attbi.com (sccrmhc02) with ESMTP
          id <2003051915102300200cffaoe>; Mon, 19 May 2003 15:10:23 +0000
Received: by lucon.org (Postfix, from userid 1000)
	id 1B75B2C683; Mon, 19 May 2003 08:10:23 -0700 (PDT)
Date: Mon, 19 May 2003 08:10:23 -0700
From: "H. J. Lu" <hjl@lucon.org>
To: Jakub Jelinek <jakub@redhat.com>
Cc: Richard Henderson <rth@redhat.com>,
	Fergus Henderson <fjh@cs.mu.oz.au>,
	John David Anglin <dave@hiauly1.hia.nrc.ca>, gcc@gcc.gnu.org,
	schwab@suse.de
Subject: Re: Does gcc violate the ia64 ABI?
Message-ID: <20030519081023.A17451@lucon.org>
References: <20030517202234.A28227@lucon.org> <200305182251.h4IMpsCD017880@hiauly1.hia.nrc.ca> <20030519030139.GA23221@ceres.cs.mu.oz.au> <20030519053855.GA25079@redhat.com> <20030519075540.A17193@lucon.org> <20030519150200.GB16629@sunsite.ms.mff.cuni.cz>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
User-Agent: Mutt/1.2.5.1i
In-Reply-To: <20030519150200.GB16629@sunsite.ms.mff.cuni.cz>; from jakub@redhat.com on Mon, May 19, 2003 at 05:02:00PM +0200
X-UIDL: 8aeb0644ea60e945aaa61fe3b0c7a135
Status: RO
Content-Length: 1364
Lines: 50

On Mon, May 19, 2003 at 05:02:00PM +0200, Jakub Jelinek wrote:
> On Mon, May 19, 2003 at 07:55:40AM -0700, H. J. Lu wrote:
> > > Only tail calls to provably local functions, apparently.
> > > I think that's pretty stupid, considering how cheap it is
> > > to reload the gp...
> > 
> > I disagree. Gcc can still do tail calls to external functions as long
> > as it reloads gp, which gcc is already doing when gp is used after
> > the call, like in this code
> > 
> > ---
> > extern void bar ();
> > 
> > static void
> > bar1 ()
> > {
> >   bar ();
> > }
> > 
> > extern int x;
> > 
> > void
> > foo ()
> > {
> >   bar1 ();
> >   x += 1;
> > }
> > ---
> > 
> > I think we just need to change the code from
> > 
> > 	reload_gp = gp is used after the tail call
> > 
> > to
> > 
> > 	reload_gp = the tail call is external
> > 
> > It may be a win since we won't reload gp for the local call even if
> > gp is used after the tail call. Besides, you have said reloading gp
> > is cheap. I don't see fixing gcc will hurt performance.
> 
> If bar1 has to reload gp after bar returns, then certainly the call to bar
> cannot be a tail call (as a tail call returns from bar stright to foo).

You reload gp when you do tail call expansion in foo, not in bar1.
But bar1 has to reload gp if it isn't expanded. I don't know if gcc
has the infrastructure to support that.


H.J.

From gcc-return-74622-obrien=freebsd.org@gcc.gnu.org  Mon May 19 13:24:55 2003
Delivered-To: obrien@freebsd.org
Return-Path: gcc-return-74622-obrien=freebsd.org@gcc.gnu.org
Received: from localhost
	by localhost with POP3 (fetchmail-6.2.0)
	for obrien@localhost (single-drop); Mon, 19 May 2003 13:24:55 -0700 (PDT)
Received: from mx1.FreeBSD.org (mx1.freebsd.org [216.136.204.125])
	by hub.freebsd.org (Postfix) with ESMTP id 8237337B405
	for <obrien@freebsd.org>; Mon, 19 May 2003 13:24:32 -0700 (PDT)
Received: from sources.redhat.com (sources.redhat.com [66.187.233.205])
	by mx1.FreeBSD.org (Postfix) with SMTP id 7395643FA3
	for <obrien@freebsd.org>; Mon, 19 May 2003 13:24:30 -0700 (PDT)
	(envelope-from gcc-return-74622-obrien=freebsd.org@gcc.gnu.org)
Received: (qmail 29430 invoked by alias); 19 May 2003 20:24:16 -0000
Mailing-List: contact gcc-help@gcc.gnu.org; run by ezmlm
Precedence: bulk
List-Unsubscribe: <mailto:gcc-unsubscribe-obrien=freebsd.org@gcc.gnu.org>
List-Archive: <http://gcc.gnu.org/ml/gcc/>
List-Post: <mailto:gcc@gcc.gnu.org>
List-Help: <http://gcc.gnu.org/ml/>
Sender: gcc-owner@gcc.gnu.org
Delivered-To: mailing list gcc@gcc.gnu.org
Received: (qmail 29337 invoked from network); 19 May 2003 20:24:15 -0000
Received: from unknown (HELO frothingslosh.sfbay.redhat.com) (66.187.237.200)
  by sources.redhat.com with SMTP; 19 May 2003 20:24:15 -0000
Received: from frothingslosh.sfbay.redhat.com (localhost.localdomain [127.0.0.1])
	by frothingslosh.sfbay.redhat.com (8.12.8/8.12.8) with ESMTP id h4JKL2K8001967;
	Mon, 19 May 2003 13:21:02 -0700
Received: (from rth@localhost)
	by frothingslosh.sfbay.redhat.com (8.12.8/8.12.8/Submit) id h4JKL0j6001965;
	Mon, 19 May 2003 13:21:00 -0700
X-Authentication-Warning: frothingslosh.sfbay.redhat.com: rth set sender to rth@redhat.com using -f
Date: Mon, 19 May 2003 13:21:00 -0700
From: Richard Henderson <rth@redhat.com>
To: "H. J. Lu" <hjl@lucon.org>
Cc: Jakub Jelinek <jakub@redhat.com>,
	Fergus Henderson <fjh@cs.mu.oz.au>,
	John David Anglin <dave@hiauly1.hia.nrc.ca>, gcc@gcc.gnu.org,
	schwab@suse.de
Subject: Re: Does gcc violate the ia64 ABI?
Message-ID: <20030519202100.GA1925@redhat.com>
Mail-Followup-To: Richard Henderson <rth@redhat.com>,
	"H. J. Lu" <hjl@lucon.org>, Jakub Jelinek <jakub@redhat.com>,
	Fergus Henderson <fjh@cs.mu.oz.au>,
	John David Anglin <dave@hiauly1.hia.nrc.ca>, gcc@gcc.gnu.org,
	schwab@suse.de
References: <20030517202234.A28227@lucon.org> <200305182251.h4IMpsCD017880@hiauly1.hia.nrc.ca> <20030519030139.GA23221@ceres.cs.mu.oz.au> <20030519053855.GA25079@redhat.com> <20030519075540.A17193@lucon.org> <20030519150200.GB16629@sunsite.ms.mff.cuni.cz> <20030519081023.A17451@lucon.org>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <20030519081023.A17451@lucon.org>
User-Agent: Mutt/1.4i
X-UIDL: 1ea68e18acc3c81e0834423bcb9123d8
Status: RO
Content-Length: 1979
Lines: 66

On Mon, May 19, 2003 at 08:10:23AM -0700, H. J. Lu wrote:
> On Mon, May 19, 2003 at 05:02:00PM +0200, Jakub Jelinek wrote:
> > On Mon, May 19, 2003 at 07:55:40AM -0700, H. J. Lu wrote:
> > > > Only tail calls to provably local functions, apparently.
> > > > I think that's pretty stupid, considering how cheap it is
> > > > to reload the gp...
> > > 
> > > I disagree. Gcc can still do tail calls to external functions as long
> > > as it reloads gp, which gcc is already doing when gp is used after
> > > the call, like in this code
> > > 
> > > ---
> > > extern void bar ();
> > > 
> > > static void
> > > bar1 ()
> > > {
> > >   bar ();
> > > }
> > > 
> > > extern int x;
> > > 
> > > void
> > > foo ()
> > > {
> > >   bar1 ();
> > >   x += 1;
> > > }
> > > ---
> > > 
> > > I think we just need to change the code from
> > > 
> > > 	reload_gp = gp is used after the tail call
> > > 
> > > to
> > > 
> > > 	reload_gp = the tail call is external
> > > 
> > > It may be a win since we won't reload gp for the local call even if
> > > gp is used after the tail call. Besides, you have said reloading gp
> > > is cheap. I don't see fixing gcc will hurt performance.
> > 
> > If bar1 has to reload gp after bar returns, then certainly the call to bar
> > cannot be a tail call (as a tail call returns from bar stright to foo).
> 
> You reload gp when you do tail call expansion in foo, not in bar1.
> But bar1 has to reload gp if it isn't expanded. I don't know if gcc
> has the infrastructure to support that.

You're not making any sense at all.

Either the GP has to be valid for the target after the call
or it doesn't.  If bar1 tail-calls to bar, then the GP isn't
valid for bar1.

Unless you're going to claim that there's a different ABI for
functions called indirectly.  (Though bar1 can't be called by
name from a different TU, it can be called via function pointer.)

And, no matter what, you couldn't tail-call to an external 
routine from a non-static function.



r~


